C-*-FORTRAN-*-
C----------------------------------------------------------------------
      integer function A_4j_ncand_2000(iana)
      implicit none
      integer iana
      integer numcand(2)
c      data numcand /14,4/ ! July LEPC numbers
      data numcand /43,10/ ! Mar 17 numbers
      if (iana.eq.1.or.iana.eq.2) then
        A_4j_ncand_2000 = numcand(iana)
      else
        A_4j_ncand_2000 = 0
        write(*,*) '<<<no such analysis branch>>>'
      endif
      end
c----------------------------------------------------------------------
      real*8 function A_4j_ecmcand_2000(iana,icand)
      implicit none
      integer iana,icand
      real*8 A_4j_discand_2000
      external A_4j_discand_2000
      A_4j_ecmcand_2000 = A_4j_discand_2000(iana,icand,0)
      end
c----------------------------------------------------------------------
      real*8 function A_4j_mhcand_2000(iana,icand)
      implicit none
      integer iana,icand
      real*8 A_4j_discand_2000
      external A_4j_discand_2000
      A_4j_mhcand_2000 = A_4j_discand_2000(iana,icand,1)
      end
c----------------------------------------------------------------------
      real*8 function A_4j_nncand_2000(iana,icand)
      implicit none
      integer iana,icand
      real*8 A_4j_discand_2000
      external A_4j_discand_2000
      A_4j_nncand_2000 = A_4j_discand_2000(iana,icand,2)
      end
c----------------------------------------------------------------------
      real*8 function A_4j_fvarcand_2000(iana,icand)
      implicit none
      integer iana,icand
      real*8 A_4j_discand_2000
      external A_4j_discand_2000
      A_4j_fvarcand_2000 = A_4j_discand_2000(iana,icand,3)
      end
c----------------------------------------------------------------------
      real*8 function A_4j_msumcand_2000(iana,icand)
      implicit none
      integer iana,icand
      real*8 A_4j_discand_2000
      external A_4j_discand_2000
      A_4j_msumcand_2000 = A_4j_discand_2000(iana,icand,4)
      end
c----------------------------------------------------------------------
      real*8 function A_4j_discand_2000(iana,icand,idis)
      implicit none
      integer iana,icand,idis
      
      integer xpt
      parameter (xpt = 5)

      real*8 cand_2b(xpt,43), cand_4b(xpt,10)
C updated to Mar 17 candidate list
      data cand_2b
     &     / 203.91, 95.95, 0.9900,  95.95, 0.9900
     &     , 203.68,109.54, 0.8846, 109.54, 0.8846
     &     , 203.61, 98.71, 0.9874,  98.71, 0.9874
     &     , 203.55, 89.33, 0.8384,  89.33, 0.8384
     &     , 204.96,103.62, 0.9955, 103.62, 0.9955
     &     , 204.65, 97.80, 0.7867,  97.80, 0.7867
     &     , 205.38, 74.99, 0.9778,  74.99, 0.9778
     &     , 205.20,113.33, 0.7721, 113.33, 0.7721
     &     , 205.14, 93.96, 0.9025,  93.96, 0.9025
     &     , 205.12, 84.66, 0.9367,  84.66, 0.9367
     &     , 204.69,109.70, 0.7749, 109.70, 0.7749
     &     , 205.11, 89.19, 0.9024,  89.19, 0.9024
     &     , 205.19,112.01, 0.8730, 112.01, 0.8730
     &     , 205.18, 98.54, 0.9736,  98.54, 0.9736
     &     , 205.16, 74.02, 0.9288,  74.02, 0.9288
     &     , 205.14,112.66, 0.8775, 112.66, 0.8775
     &     , 206.33,106.34, 0.9409, 106.34, 0.9409
     &     , 206.39, 92.27, 0.9568,  92.27, 0.9568
     &     , 206.37,102.46, 0.8717, 102.46, 0.8717
     &     , 206.40,114.18, 0.8494, 114.18, 0.8494
     &     , 206.38,114.38, 0.9330, 114.38, 0.9330
     &     , 206.38,101.16, 0.9322, 101.16, 0.9322
     &     , 205.98, 99.17, 0.7935,  99.17, 0.7935
     &     , 205.99, 95.82, 0.8115,  95.82, 0.8115
     &     , 206.37, 84.21, 0.9624,  84.21, 0.9624
     &     , 206.37,102.30, 0.9756, 102.30, 0.9756
     &     , 206.37, 99.94, 0.8491,  99.94, 0.8491
     &     , 206.45, 95.28, 0.9268,  95.28, 0.9268
     &     , 206.39,110.11, 0.9544, 110.11, 0.9544
     &     , 206.38,107.25, 0.9344, 107.25, 0.9344
     &     , 206.37,104.69, 0.7981, 104.69, 0.7981
     &     , 206.15,111.75, 0.8993, 111.75, 0.8993
     &     , 206.61,114.15, 0.9966, 114.15, 0.9966
     &     , 206.59,108.98, 0.8997, 108.98, 0.8997
     &     , 206.57, 98.40, 0.8618,  98.40, 0.8618
     &     , 206.57, 92.00, 0.9724,  92.00, 0.9724
     &     , 206.57, 91.93, 0.8955,  91.93, 0.8955
     &     , 206.58,100.24, 0.8335, 100.24, 0.8335
     &     , 207.38,102.80, 0.9937, 102.80, 0.9937
     &     , 206.66, 93.02, 0.8775,  93.02, 0.8775
     &     , 206.61, 92.62, 0.7832,  92.62, 0.7832
     &     , 206.86,100.95, 0.8965, 100.95, 0.8965
     &     , 208.03,102.20, 0.9659, 102.20, 0.9659
     &     /
C updated to Mar 17 cand list
      data cand_4b
     &     / 205.13, 93.77, 0.9857, 195.42, 124.47
     &     , 204.76, 85.83, 0.9526, 231.01, 119.11
     &     , 206.37, 77.50, 0.9627, 225.02, 168.70
     &     , 206.36,109.93, 0.9987, 268.36, 201.13
     &     , 206.17, 89.86, 0.9591, 259.36, 181.06
     &     , 206.62, 88.49, 0.9950,  43.34, 113.46
     &     , 206.65,112.80, 0.9963, 119.83, 189.55
     &     , 206.57, 89.13, 0.6818, 243.68, 180.33
     &     , 206.57, 96.89, 0.7928, 228.95, 188.09
     &     , 206.61, 87.41, 0.9424, 206.17, 178.61
     &     /
      SAVE

      if (iana.eq.1) then
         A_4j_discand_2000 = cand_2b(idis+1,icand)
      else if (iana.eq.2) then
        if (idis.eq.2) then
          A_4j_discand_2000 = log10(1.0001-cand_4b(idis+1,icand))
        else
          A_4j_discand_2000 = cand_4b(idis+1,icand)
        endif
      endif
      end
c----------------------------------------------------------------------
      integer function A2000_nn_ncand()
      implicit none
      A2000_nn_ncand = 39 ! Hnn candidates
      end
c---------------------------------------------------------------------- 
      subroutine A2000_nn_mhcand(icand,massc,btagc,ecmc)
      implicit none
      integer icand,i
      integer maxcand
      real massc,btagc,ecmc
      parameter (maxcand=39) ! Hnn candidates 
      real*8 mass(maxcand),btag(maxcand),ecm(maxcand)
      data (mass(i),btag(i),ecm(i), i=1,maxcand)
     & /  97.9418, 0.8451, 201.7110,
     &   101.3633, 0.0330, 203.9570,
     &    94.8692, 0.3024, 203.5170,
     &    90.9852, 0.0015, 204.7910,
     &    97.6478, 0.0177, 205.0630,
     &    89.5949, 0.2605, 205.1220,
     &   105.6788, 0.3103, 205.1170,
     &    89.1231, 0.0018, 205.0670,
     &    96.3871, 0.4649, 205.1110,
     &    97.9252, 0.0809, 205.2020,
     &    93.6093, 0.0000, 205.0800,
     &   102.7563, 0.1280, 205.0930,
     &    98.5992, 0.0287, 205.0830,
     &   108.0446, 0.1035, 205.0900,
     &    97.7095, 0.1155, 205.1310,
     &    99.8095, 0.4047, 205.2980,
     &   104.6771, 0.2453, 205.1750,
     &   111.8318, 0.1228, 205.1900,
     &   106.1861, 0.0446, 206.4450,
     &    97.7256, 0.0956, 206.1000,
     &   106.0017, 0.0883, 206.2960,
     &    99.0190, 0.0006, 206.2230,
     &   103.2646, 0.0147, 206.3800,
     &   108.9919, 0.0736, 206.3610,
     &    95.7122, 0.1298, 206.3850,
     &   104.5867, 0.0058, 206.3840,
     &    91.9384, 0.8607, 206.3350,
     &   100.4554, 0.0202, 206.3390,
     &    93.2242, 0.0119, 206.5480,
     &    96.2771, 0.3708, 206.1820,
     &   101.7291, 0.0000, 206.3740,
     &   112.2677, 0.0046, 206.6860,
     &   104.0649, 0.0006, 206.7110,
     &    96.6599, 0.1830, 206.5600,
     &    99.7180, 0.0522, 206.6200,
     &   100.4732, 0.0403, 206.5570,
     &    90.4756, 0.1659, 206.5620,
     &   104.7760, 0.0486, 206.6620,
     &   106.9553, 0.0315, 206.5820
     &   /

      if (icand.gt.maxcand) then
         massc=0.d0
         btagc=0.d0
         ecmc=0.d0
      else 
         massc=mass(icand)
         btagc=btag(icand)
         ecmc=ecm(icand)
      endif
      end
c----------------------------------------------------------------------
C-*-FORTRAN-*-
C
      subroutine a2000_hll_cand(iebin,ncand,hll_mass,hll_btag)
C
C     Return the number of Hll candidates in the large energy bin IEBIN 
C     The candidate properties are also returned in 
C     the arrays hll_mass, hll_btag
C                                    P Teixeira-Dias, 15-June-2000.
C
C     - final update of candidates for July 20, LEPC; PTD, 11-Jul-2000.
C
      implicit none
      integer i,ncand,nmax,ntotal,iebin,n1,n2
      parameter (n1=50,n2=500)
      logical first
      data first /.true./
      real emin,emax,hll_mass(n1),hll_btag(n1),
     +     ecms(n2),mass(n2),btag(n2)
      save ecms,mass,btag,ntotal
c
      include 'a_2000_vars.inc'
c
      if (FIRST) then
         FIRST = .false.
c
c     Fill in the database:
c     ecms,mass&btau-tag for each candidate
c     ntotal=total number of candidates in database
         ntotal = 1
c
         ecms(ntotal) = 203.6740
         mass(ntotal) = 96.7939
         btag(ntotal) = 0.2135 
c
c---- This candidate is in a run DUCKed at the 
c     data quality meeting of July 10, 2000:
c         ntotal = ntotal + 1
c         ecms(ntotal) = 204.94
c         mass(ntotal) = 100.1571
c         btag(ntotal) = 1.180510
c
         ntotal = ntotal + 1
         ecms(ntotal) = 204.8900
         mass(ntotal) = 86.7950
         btag(ntotal) = 0.2318
c
         ntotal = ntotal + 1
         ecms(ntotal) = 204.8170
         mass(ntotal) = 118.1755
         btag(ntotal) = 0.7971
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.0320
         mass(ntotal) = 50.2405
         btag(ntotal) = 0.2639
c
         ntotal = ntotal + 1
         ecms(ntotal) = 204.9500
         mass(ntotal) = 90.4536
         btag(ntotal) = 1.2660
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1750
         mass(ntotal) = 91.9463
         btag(ntotal) = 0.5743
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1150
         mass(ntotal) = 99.8691
         btag(ntotal) = 0.4998
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1190
         mass(ntotal) = 117.3311
         btag(ntotal) = 1.4165
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1160
         mass(ntotal) = 121.4211
         btag(ntotal) = 0.2971
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1380
         mass(ntotal) = 114.9040
         btag(ntotal) = 0.5045
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1170
         mass(ntotal) = 91.7594
         btag(ntotal) = 0.1751
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1190
         mass(ntotal) = 95.5478
         btag(ntotal) = 0.0417
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1940
         mass(ntotal) = 96.7603
         btag(ntotal) = 1.5772
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1650
         mass(ntotal) = 86.1097
         btag(ntotal) = 0.6008
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 205.1350
         mass(ntotal) = 55.5005
         btag(ntotal) = 0.4478
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.3700
         mass(ntotal) = 67.4847
         btag(ntotal) = 0.0000
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.3690
         mass(ntotal) = 87.1467
         btag(ntotal) = 1.8439
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.3560
         mass(ntotal) = 94.3650
         btag(ntotal) = 2.0000
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.5630
         mass(ntotal) = 88.5850
         btag(ntotal) = 0.5837
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.4030
         mass(ntotal) = 89.8192
         btag(ntotal) = 1.1520
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.3490
         mass(ntotal) = 88.8776
         btag(ntotal) = 1.7170
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.3800
         mass(ntotal) = 93.9122
         btag(ntotal) = 0.2604
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.3940
         mass(ntotal) = 96.2171
         btag(ntotal) = 0.2567
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.5870
         mass(ntotal) = 100.2503
         btag(ntotal) = 0.9084
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.7190
         mass(ntotal) = 85.4569
         btag(ntotal) = 0.0984
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.5860
         mass(ntotal) = 87.1388
         btag(ntotal) = 1.9720
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.5890
         mass(ntotal) = 83.4148
         btag(ntotal) = 0.7218
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.6290
         mass(ntotal) = 110.8205
         btag(ntotal) = 0.3897
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 206.5540
         mass(ntotal) = 100.5722
         btag(ntotal) = 0.1897
c
         ntotal = ntotal + 1 
         ecms(ntotal) = 208.2340
         mass(ntotal) = 81.3828
         btag(ntotal) = 0.1696
c

c
c         write (6,*) '+---------------------------------------------+'
c         write (6,*) '| Hll candidates from BEHOLD <= 11/07/2000. '
c         write (6,*) '| Last considered RUN NO: ',
c         write (6,*) '| Ncandidates in Y2000 database = ',ntotal
c         write (6,*) '+---------------------------------------------+'
c
      end if                    ! FIRST
c
c     Initialize output variables
c
      ncand = 0
      call vzero(hll_mass,n1)
      call vzero(hll_btag,n1)
c
c     Boundaries for thsi energy bin are:
c
      emin = 199.+0.1*(ilow_energy(iebin)-1)
      emax = 199.+0.1*(ihigh_energy(iebin))
c      write (6,*) 'Searching for the Hll-2000 candidates in the range',
c     +     emin,emax,' GeV.'
c
c     Search the database for all candidates in [Emin,Emax[
c
      do i=1,ntotal
         if (ecms(i).ge.emin .AND. ecms(i).lt.emax) then
            ncand = ncand + 1
            hll_mass(ncand) = mass(i)
            hll_btag(ncand) = btag(i)
         end if
      end do                    ! ntotal
c
      return
      end
c----------------------------------------------------------------------
C-*-FORTRAN-*-
C
      subroutine a2000_xtt_cand(iebin,ncand,xtt_mass,ibranch)
C
C     Return the number of Cuts 4-jet candidates in the large energy bin
C     IEBIN 
C     The branch (ibranch) is defined by the user
C     thus func can return hzexcl,haexcl,ovlpha,ovlphz
C     The candidate properties are also returned in 
C     the arrays xtt_mass,
C                                    J Kennedy, June-2000.
c     Modified:
c     - minor changes, to update JK's version (for 4jets CUTS) to Xtt;
c                                    PTD, 02-Jul-2000.
C
C     - final update of candidates for July 20, LEPC; PTD, 11-Jul-2000.
C
C
      implicit none
      integer i,ncand,nmax,ntotal,iebin,n1,n2,ibranch
      parameter (n1=50,n2=500)
      logical first
      data first /.true./
      real emin,emax,xtt_mass(n1),
     +     ecms(n2),mass(n2),btag(n2),branch(n2)
      save ecms,mass,ntotal
c
      include 'a_2000_vars.inc'
c
      if (FIRST) then
         FIRST = .false.
c
c     Fill in the database:
c     ecms, mass & branch for each candidate
c     ntotal=total number of candidates in database
         ntotal = 1
c
c++hz excl (ibranch=4)
c
         ecms(ntotal) = 204.6330
         mass(ntotal) = 83.1715
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1320
         mass(ntotal) = 112.6185
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1000
         mass(ntotal) = 75.0468
         branch(ntotal) = 4
c
         ntotal = ntotal + 1  
         ecms(ntotal) = 205.1280
         mass(ntotal) = 77.0547
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.9480
         mass(ntotal) = 87.6142
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.4310
         mass(ntotal) = 92.9677
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.3620
         mass(ntotal) = 117.0271
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.5710
         mass(ntotal) = 88.2534
         branch(ntotal) = 4
c
         ntotal = ntotal + 1  
         ecms(ntotal) = 206.1420
         mass(ntotal) = 80.5260
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 206.5740
         mass(ntotal) = 89.0957
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 207.9730
         mass(ntotal) = 115.2272
         branch(ntotal) = 4
c
         ntotal = ntotal + 1
         ecms(ntotal) = 208.2570
         mass(ntotal) = 100.7181
         branch(ntotal) = 4
c
c++ha excl (ibranch=1)
c
         ntotal = ntotal + 1
         ecms(ntotal) = 205.1350
         mass(ntotal) = 76.8438
         branch(ntotal) = 1
c
c++ovlap as hz (ibranch=3)
c
         ntotal = ntotal + 1
         ecms(ntotal) = 204.9880
         mass(ntotal) = 87.7612
         branch(ntotal) = 3
c
         ntotal = ntotal + 1
         ecms(ntotal) = 208.0030
         mass(ntotal) = 94.1654
         branch(ntotal) = 3

c
c++ovlap as ha (ibranch=2)
c
         ntotal = ntotal + 1
         ecms(ntotal) = 204.9880
         mass(ntotal) = 92.1872
         branch(ntotal) = 2
c
         ntotal = ntotal + 1
         ecms(ntotal) = 208.0030
         mass(ntotal) = 92.5396
         branch(ntotal) = 2

c
c         write (6,*) '+---------------------------------------------+'
c         write (6,*) '| Xtt candidates from BEHOLD <= 26/06/2000. '
c         write (6,*) '| Last considered RUN NO: ',54984
c         write (6,*) '| N(entries) in Y2000 database = ',ntotal
c         write (6,*) '+---------------------------------------------+'
c
      end if                    ! FIRST
c
c     Initialize output variables
c
      ncand = 0
      call vzero(xtt_mass,n1)
c
c     Boundaries for thsi energy bin are:
c
      emin = 199.+0.1*(ilow_energy(iebin)-1)
      emax = 199.+0.1*(ihigh_energy(iebin))
c      write (6,*) 'Searching for the C4J-2000 candidates in the range',
c     +     emin,emax,' GeV.'
c
c     Search the database for all candidates in [Emin,Emax]
c
      do i=1,ntotal
	if(branch(i).eq.ibranch) then
         if (ecms(i).ge.emin .AND. ecms(i).lt.emax) then
            ncand = ncand + 1
            xtt_mass(ncand) = mass(i)
         end if
	endif
      end do                    ! ntotal
c
      return
      end
