C-*-FORTRAN-*-
C
c
c 192-202 Channels 
c
c Four Jets -- three analyses

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        do iener = 1,4
           if (iener.eq.1) ener = 191.6
           if (iener.eq.2) ener = 195.5
           if (iener.eq.3) ener = 199.5
           if (iener.eq.4) ener = 201.6
        do ichan = 1,3
          if (ichan.eq.1) iana = 2
          if (ichan.eq.2) iana = 2
          if (ichan.eq.3) iana = 1
          if (iener.eq.1) then
            if ((ichan.eq.1).and.(iopt.eq.1)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 191.6 4b (opt 1)'
            else if ((ichan.eq.1).and.(iopt.eq.0)) then
              nchan = nchan + 1
              channame(nchan) = 'ALEPH 191.6 4b (auto)'
            else if ((ichan.eq.2).and.(iopt.eq.2)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 191.6 4b (opt 2)'
            else if (ichan.eq.3) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 191.6 2b'
            endif
          else if (iener.eq.2) then
            if ((ichan.eq.1).and.(iopt.eq.1)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 195.5 4b (opt 1)'
            else if ((ichan.eq.1).and.(iopt.eq.0)) then
              nchan = nchan + 1
              channame(nchan) = 'ALEPH 195.5 4b (auto)'
            else if ((ichan.eq.2).and.(iopt.eq.2)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 195.5 4b (opt 2)'
            else if (ichan.eq.3) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 195.5 2b'
            endif
          else if (iener.eq.3) then
            if ((ichan.eq.1).and.(iopt.eq.1)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 199.5 4b (opt 1)'
            else if ((ichan.eq.1).and.(iopt.eq.0)) then
              nchan = nchan + 1
              channame(nchan) = 'ALEPH 199.5 4b (auto)'
            else if ((ichan.eq.2).and.(iopt.eq.2)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 199.5 4b (opt 2)'
            else if (ichan.eq.3) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 199.5 2b'
            endif
          else if (iener.eq.4) then
            if ((ichan.eq.1).and.(iopt.eq.1)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 201.6 4b (opt 1)'
            else if ((ichan.eq.1).and.(iopt.eq.0)) then
              nchan = nchan + 1
              channame(nchan) = 'ALEPH 201.6 4b (auto)'
            else if ((ichan.eq.2).and.(iopt.eq.2)) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 201.6 4b (opt 2)'
            else if (ichan.eq.3) then
              nchan = nchan + 1 
              channame(nchan) = 'ALEPH 201.6 2b'
            endif
          endif

          nbinsint1 = 100
          nbinsint2 = 100
          nbinsint  = 100
c
          xlzh = xhz(15+iener)*ah0_lumi(iener+2)
          xlah = xha(15+iener)*ah0_lumi(iener+2)
          xlzh2 = xhz2(15+iener)*ah0_lumi(iener+2)
          xlah2 = xha2(15+iener)*ah0_lumi(iener+2)
          chanlumi(nchan) = ah0_lumi(iener+2)

          xdouble = mh
          ydouble = mapole
          xdouble2 = mh2
          ydouble2 = mapole2
          ratech = SNGL(A_4j_eff(xdouble,ener,iana,1,1))*
     >                  z0toh*xlzh*bhbb
          if (xtest19x) write (6,*) '4 jets only',ener,ratech
          rate2ch= SNGL(A_4j_eff((xdouble+ydouble)/2D0,
     >                  ener,iana,2,1))*
     >                  bhbb*babb*xlah
          ratech2 = SNGL(A_4j_eff(xdouble2,ener,iana,1,1))*
     >                  z0toh*xlzh2*bhbb2
          if (xtest19x) write (6,*) '4 jets only',ener,ratech
          rate2ch2= SNGL(A_4j_eff((xdouble2+ydouble2)/2D0,
     >                  ener,iana,2,1))*
     >                  bhbb2*babb2*xlah2
          if (ratech.lt.0.0) ratech=0.0
          if (rate2ch.lt.0.0) rate2ch=0.0
          if (ratech2.lt.0.0) ratech2=0.0
          if (rate2ch2.lt.0.0) rate2ch2=0.0

c create binned shape info
          if (xtest19x) write (6,*) 'ichan,iopt2',ichan,iopt2
          IF ((ICHAN.EQ.1).and.(iopt2.eq.1)) THEN
C hZ/hA 4b branch, Option 1 (using "hZ shapes": mH and NN)
            xl1 = 40.
            xu1 = ener-91.2
            xl2 = 0.
            xu2 = 1.000
cx            nbinsint1 = 100
cx            nbinsint2 = 100
cx            nbinsint  = 100
            IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1921 ! NEXT CHANNEL
          
            nerrch(nchan) = 12
            if (iener.eq.1) then
              sysname(1,nchan) = 'A192-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A192-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A192-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A192-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A192-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A192-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.2) then
              sysname(1,nchan) = 'A196-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A196-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A196-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A196-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A196-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A196-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.3) then
              sysname(1,nchan) = 'A200-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A200-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A200-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A200-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A200-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A200-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.4) then
              sysname(1,nchan) = 'A202-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A202-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A202-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A202-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A202-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A202-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            endif
            if ((ratech+rate2ch).ne.0.) then
              dsig(1,nchan) = sqrt( (ratech*0.037)**2 +
     >                              (rate2ch*0.016)**2)/
     >                              (ratech+rate2ch)
              dsig(2,nchan) = 0.
              dsig(3,nchan) = sqrt( (ratech*0.0048)**2 +
     >                              (rate2ch*0.0055)**2)/
     >                              (ratech+rate2ch)
              dsig(4,nchan) = 0.
              dsig(5,nchan) =     ( (ratech*0.025) +
     >                              (rate2ch*0.011))/
     >                              (ratech+rate2ch)
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.0059
              dsig(8,nchan) = 0.015
              dsig(9,nchan) = 0.014
              dsig(10,nchan)= 0.
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            else
              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.
              dsig(8,nchan) = 0.
              dsig(9,nchan) = 0.
              dsig(10,nchan)= 0.
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            endif
            dback(1,nchan) = 0.
            dback(2,nchan) = 0.
            dback(3,nchan) = 0.
            dback(4,nchan) = 0.
            dback(5,nchan) = 0.
            dback(6,nchan) = 0.
            dback(7,nchan) = 0.
            dback(8,nchan) = 0.
            dback(9,nchan) = 0.
            dback(10,nchan) = 0.
            dback(11,nchan) = 0.
            dback(12,nchan) = 0.

            call a2dzero1(nbinsint1,nbinsint2,sighist2d)
            call a2dzero1(nbinsint1,nbinsint2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >                     xdouble,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >                     xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >                     xdouble2,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >                     xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                   sighist1,sighist2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >           (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >           (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >           (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >           (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch2,
     >                   sighist1,sighist2,sighist2d2)

            call a2dzero1(nbinsint1,nbinsint2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,1,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,1,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,1)*ah0_lumi(iener+2)
            bkgtotal = bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.134)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.009)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.183)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.011)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.044)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.049)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)+ (bkglevel*0.075)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,2,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,2,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,2)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.192)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.019)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.400)
            dback(7,nchan) = dback(7,nchan)
            dback(8,nchan) = dback(8,nchan)
            dback(9,nchan) = dback(9,nchan)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,3,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,3,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,3)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.056)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.0095)**2
            dback(5,nchan) = dback(5,nchan) + (bkglevel*0.053)
            dback(6,nchan) = dback(6,nchan)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.0063)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.018)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.015)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)

            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = sqrt(dback(2,nchan))/bkgtotal
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = sqrt(dback(3,nchan))/bkgtotal
            dback(5,nchan) = dback(5,nchan)/bkgtotal
            dback(6,nchan) = dback(6,nchan)/bkgtotal
            dback(7,nchan) = dback(7,nchan)/bkgtotal
            dback(8,nchan) = dback(8,nchan)/bkgtotal
            dback(9,nchan) = dback(9,nchan)/bkgtotal
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= sqrt(dback(11,nchan))/bkgtotal
            dback(12,nchan)= dback(12,nchan)/bkgtotal

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call a2dzero2(nbinsint1,nbinsint2,candhist2d)
            nacand = A_4j_NCAND(ener,iana)
            do i=1,nacand
              candmass = A_4j_MH_CAND(ener,iana,i)
              candbtag = A_4j_NN_CAND(ener,iana,i)


              call abin1(candmass,xl1,xu1,
     >                   nbinsint1,ibin1)
              call abin1(candbtag,xl2,xu2,
     >                   nbinsint2,ibin2)
              if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +          candhist2d(ibin1,ibin2) = candhist2d(ibin1,ibin2)+1
            enddo

            call arebin5(nbinsint1,nbinsint2,
     >                   sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                   nbinsint,sig(nbins+1),
     >                   sig2(nbins+1),backw(nbins+1),
     >                   ncand(nbins+1))
c systematics
            if (.not.subbg) then
              call vzero(backg(nbins+1),nbinsint)
            elseif (dosyst) then
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            else
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            endif
cx            ifirst(nchan) = nbins + 1
cx            nbins = nbins + nbinsint

C hZ/hA 4b branch, Option 2 (using "hA shapes": Msum and b-tag)

          else if ((ichan.eq.2).and.(iopt2.eq.2)) then
            xl1 = 30.
            xu1 = ener
            xl2 = -100.
            xu2 = 272.
cx            nbinsint1 = 100
cx            nbinsint2 = 100
cx            nbinsint  = 100
            IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1921 ! NEXT CHANNEL
          
            nerrch(nchan) = 12
            if (iener.eq.1) then
              sysname(1,nchan) = 'A192-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A192-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A192-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A192-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A192-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A192-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.2) then
              sysname(1,nchan) = 'A196-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A196-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A196-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A196-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A196-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A196-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.3) then
              sysname(1,nchan) = 'A200-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A200-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A200-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A200-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A200-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A200-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.4) then
              sysname(1,nchan) = 'A202-4B-MCSTAT-SIG'
              sysname(2,nchan) = 'A202-4B-MCSTAT-BKG'
              sysname(3,nchan) = 'A202-4B-JETSMR-SIG'
              sysname(4,nchan) = 'A202-4B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A202-4B-SELVAR-SIG'
              sysname(11,nchan)= 'A202-4B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            endif
            if ((ratech+rate2ch).ne.0.) then
              dsig(1,nchan) = sqrt( (ratech*0.037)**2 +
     >                              (rate2ch*0.016)**2)/
     >                              (ratech+rate2ch)
              dsig(2,nchan) = 0.
              dsig(3,nchan) = sqrt( (ratech*0.0048)**2 +
     >                              (rate2ch*0.0055)**2)/
     >                              (ratech+rate2ch)
              dsig(4,nchan) = 0.
              dsig(5,nchan) =     ( (ratech*0.025) +
     >                              (rate2ch*0.011))/
     >                              (ratech+rate2ch)
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.0059
              dsig(8,nchan) = 0.015
              dsig(9,nchan) = 0.014
              dsig(10,nchan)= 0.
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            else
              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.
              dsig(8,nchan) = 0.
              dsig(9,nchan) = 0.
              dsig(10,nchan)= 0.
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            endif
            dback(1,nchan) = 0.
            dback(2,nchan) = 0.
            dback(3,nchan) = 0.
            dback(4,nchan) = 0.
            dback(5,nchan) = 0.
            dback(6,nchan) = 0.
            dback(7,nchan) = 0.
            dback(8,nchan) = 0.
            dback(9,nchan) = 0.
            dback(10,nchan) = 0.
            dback(11,nchan) = 0.
            dback(12,nchan) = 0.

            call a2dzero1(nbinsint1,nbinsint2,sighist2d)
            call a2dzero1(nbinsint1,nbinsint2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_msum,
     >                     xdouble,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_fvar,
     >                     xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_msum,
     >                     xdouble2,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_fvar,
     >                     xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                   sighist1,sighist2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_msum,
     >           (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_fvar,
     >           (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_msum,
     >           (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_fvar,
     >           (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch2,
     >                   sighist1,sighist2,sighist2d2)

            call a2dzero1(nbinsint1,nbinsint2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_msum,
     >                      A_4j_bkg,iana,1,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_fvar,
     >                      A_4j_bkg,iana,1,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,1)*ah0_lumi(iener+2)
            bkgtotal = bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.134)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.009)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.183)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.011)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.044)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.049)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)+ (bkglevel*0.075)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_msum,
     >                      A_4j_bkg,iana,2,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_fvar,
     >                      A_4j_bkg,iana,2,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,2)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.192)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.019)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.400)
            dback(7,nchan) = dback(7,nchan)
            dback(8,nchan) = dback(8,nchan)
            dback(9,nchan) = dback(9,nchan)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_msum,
     >                      A_4j_bkg,iana,3,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_fvar,
     >                      A_4j_bkg,iana,3,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,3)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.056)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.0095)**2
            dback(5,nchan) = dback(5,nchan) + (bkglevel*0.053)
            dback(6,nchan) = dback(6,nchan)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.0063)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.018)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.015)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)
            dback(12,nchan)= dback(12,nchan)

            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = sqrt(dback(2,nchan))/bkgtotal
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = sqrt(dback(3,nchan))/bkgtotal
            dback(5,nchan) = dback(5,nchan)/bkgtotal
            dback(6,nchan) = dback(6,nchan)/bkgtotal
            dback(7,nchan) = dback(7,nchan)/bkgtotal
            dback(8,nchan) = dback(8,nchan)/bkgtotal
            dback(9,nchan) = dback(9,nchan)/bkgtotal
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= sqrt(dback(11,nchan))/bkgtotal
            dback(12,nchan)= dback(12,nchan)/bkgtotal

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call a2dzero2(nbinsint1,nbinsint2,candhist2d)
            nacand = A_4j_NCAND(ener,iana)
            do i=1,nacand
              candmass = A_4j_MSUM_CAND(ener,iana,i)
              candbtag = A_4j_FVAR_CAND(ener,iana,i)


              call abin1(candmass,xl1,xu1,
     >                   nbinsint1,ibin1)
              call abin1(candbtag,xl2,xu2,
     >                   nbinsint2,ibin2)
              if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +          candhist2d(ibin1,ibin2) = candhist2d(ibin1,ibin2)+1
            enddo

            call arebin5(nbinsint1,nbinsint2,
     >                   sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                   nbinsint,sig(nbins+1),
     >                   sig2(nbins+1),backw(nbins+1),
     >                   ncand(nbins+1))
c systematics
            if (.not.subbg) then
              call vzero(backg(nbins+1),nbinsint)
            elseif (dosyst) then
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            else
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            endif
cx            ifirst(nchan) = nbins + 1
cx            nbins = nbins + nbinsint

          ELSE IF (ICHAN.EQ.3) THEN 
            xl1 = 40.
            xu1 = ener-91.2
            xl2 = 0.763
            xu2 = 1.000
            IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1921 ! NEXT CHANNEL

            nerrch(nchan) = 12
            if (iener.eq.1) then
              sysname(1,nchan) = 'A192-2B-MCSTAT-SIG'
              sysname(2,nchan) = 'A192-2B-MCSTAT-BKG'
              sysname(3,nchan) = 'A192-2B-JETSMR-SIG'
              sysname(4,nchan) = 'A192-2B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A192-2B-SELVAR-SIG'
              sysname(11,nchan)= 'A192-2B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.2) then
              sysname(1,nchan) = 'A196-2B-MCSTAT-SIG'
              sysname(2,nchan) = 'A196-2B-MCSTAT-BKG'
              sysname(3,nchan) = 'A196-2B-JETSMR-SIG'
              sysname(4,nchan) = 'A196-2B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A196-2B-SELVAR-SIG'
              sysname(11,nchan)= 'A196-2B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.3) then
              sysname(1,nchan) = 'A200-2B-MCSTAT-SIG'
              sysname(2,nchan) = 'A200-2B-MCSTAT-BKG'
              sysname(3,nchan) = 'A200-2B-JETSMR-SIG'
              sysname(4,nchan) = 'A200-2B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A200-2B-SELVAR-SIG'
              sysname(11,nchan)= 'A200-2B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            else if (iener.eq.4) then
              sysname(1,nchan) = 'A202-2B-MCSTAT-SIG'
              sysname(2,nchan) = 'A202-2B-MCSTAT-BKG'
              sysname(3,nchan) = 'A202-2B-JETSMR-SIG'
              sysname(4,nchan) = 'A202-2B-JETSMR-BKG'
              sysname(5,nchan) = 'A19X-BSMR-BB'
              sysname(6,nchan) = 'A19X-BSMR-LT'
              sysname(7,nchan) = 'BLIFE'
              sysname(8,nchan) = 'BHADCHDECMULT'
              sysname(9,nchan) = 'BFRAG'
              sysname(10,nchan)= 'A202-2B-SELVAR-SIG'
              sysname(11,nchan)= 'A202-2B-SELVAR-BKG'
              sysname(12,nchan)= 'GTOBBCC'
            endif

            if ((ratech+rate2ch).ne.0.) then
              dsig(1,nchan) = sqrt( (ratech*0.018)**2 +
     >                              (rate2ch*0.025)**2)/
     >                              (ratech+rate2ch)
              dsig(2,nchan) = 0.
              dsig(3,nchan) = sqrt( (ratech*0.010)**2 +
     >                              (rate2ch*0.0065)**2)/
     >                              (ratech+rate2ch)
              dsig(4,nchan) = 0.
              dsig(5,nchan) =     ( (ratech*0.00033) +
     >                              (rate2ch*0.017))/
     >                              (ratech+rate2ch)
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.0059
              dsig(8,nchan) = 0.015
              dsig(9,nchan) = 0.014
              dsig(10,nchan)= 0.0105
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            else
              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.
              dsig(7,nchan) = 0.
              dsig(8,nchan) = 0.
              dsig(9,nchan) = 0.
              dsig(10,nchan)= 0.
              dsig(11,nchan)= 0.
              dsig(12,nchan)= 0.
            endif
            dback(1,nchan) = 0.
            dback(2,nchan) = 0.
            dback(3,nchan) = 0.
            dback(4,nchan) = 0.
            dback(5,nchan) = 0.
            dback(6,nchan) = 0.
            dback(7,nchan) = 0.
            dback(8,nchan) = 0.
            dback(9,nchan) = 0.
            dback(10,nchan) = 0.
            dback(11,nchan) = 0.
            dback(12,nchan) = 0.

            call a2dzero1(nbinsint1,nbinsint2,sighist2d)
            call a2dzero1(nbinsint1,nbinsint2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >                     xdouble,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >                     xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >                     xdouble2,iana,1,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >                     xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
            call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                   sighist1,sighist2,sighist2d2)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >          (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >          (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                   sighist1,sighist2,sighist2d)

            call ascreateB(xl1,xu1,nbinsint1,A_4j_sig_mh,
     >          (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
            call ascreateB(xl2,xu2,nbinsint2,A_4j_sig_nn,
     >          (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

            call a2dadd1(nbinsint1,nbinsint2,rate2ch2,
     >                   sighist1,sighist2,sighist2d2)

            call a2dzero1(nbinsint1,nbinsint2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,1,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,1,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,1)*ah0_lumi(iener+2)
            bkgtotal = bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.054)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.0029)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.009)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.011)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.044)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.049)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)+ (bkglevel*0.054)**2
            dback(12,nchan)= dback(12,nchan)+ (bkglevel*0.075)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,2,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,2,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,2)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.031)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.016)**2
            dback(5,nchan) = dback(5,nchan)
            dback(6,nchan) = dback(6,nchan) + (bkglevel*0.056)
            dback(7,nchan) = dback(7,nchan)
            dback(8,nchan) = dback(8,nchan)
            dback(9,nchan) = dback(9,nchan)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)+ (bkglevel*0.033)**2
            dback(12,nchan)= dback(12,nchan)

            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call abhcreateB(xl1,xu1,nbinsint1,A_4j_bkg_mh,
     >                      A_4j_bkg,iana,3,ener,backhist1)
            call abhcreateB(xl2,xu2,nbinsint1,A_4j_bkg_nn,
     >                      A_4j_bkg,iana,3,ener,backhist2)
            bkglevel = A_4j_bkg(ener,iana,3)*ah0_lumi(iener+2)
            bkgtotal = bkgtotal + bkglevel
            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = dback(2,nchan) + (bkglevel*0.025)**2
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = dback(4,nchan) + (bkglevel*0.0049)**2
            dback(5,nchan) = dback(5,nchan) + (bkglevel*0.0026)
            dback(6,nchan) = dback(6,nchan)
            dback(7,nchan) = dback(7,nchan) + (bkglevel*0.0063)
            dback(8,nchan) = dback(8,nchan) + (bkglevel*0.018)
            dback(9,nchan) = dback(9,nchan) + (bkglevel*0.015)
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= dback(11,nchan)+ (bkglevel*0.035)**2
            dback(12,nchan)= dback(12,nchan)

            dback(1,nchan) = dback(1,nchan)
            dback(2,nchan) = sqrt(dback(2,nchan))/bkgtotal
            dback(3,nchan) = dback(3,nchan)
            dback(4,nchan) = sqrt(dback(3,nchan))/bkgtotal
            dback(5,nchan) = dback(5,nchan)/bkgtotal
            dback(6,nchan) = dback(6,nchan)/bkgtotal
            dback(7,nchan) = dback(7,nchan)/bkgtotal
            dback(8,nchan) = dback(8,nchan)/bkgtotal
            dback(9,nchan) = dback(9,nchan)/bkgtotal
            dback(10,nchan)= dback(10,nchan)
            dback(11,nchan)= sqrt(dback(11,nchan))/bkgtotal
            dback(12,nchan)= dback(12,nchan)/bkgtotal


            call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                   backhist1,backhist2,bkghist2d)

            call a2dzero2(nbinsint1,nbinsint2,candhist2d)
            nacand = A_4j_NCAND(ener,iana)
            do i=1,nacand
              candmass = A_4j_MH_CAND(ener,iana,i)
              candbtag = A_4j_NN_CAND(ener,iana,i)

              call abin1(candmass,xl1,xu1,
     >                   nbinsint1,ibin1)
              call abin1(candbtag,xl2,xu2,
     >                   nbinsint2,ibin2)

              if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +          candhist2d(ibin1,ibin2) = candhist2d(ibin1,ibin2)+1
            enddo

            call arebin5(nbinsint1,nbinsint2,
     >                   sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                   nbinsint,sig(nbins+1),
     >                   sig2(nbins+1),backw(nbins+1),
     >                   ncand(nbins+1))
c systematics
            if (.not.subbg) then
              call vzero(backg(nbins+1),nbinsint)
            elseif (dosyst) then
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            else
              call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                    nbinsint)
            endif
cx            ifirst(nchan) = nbins + 1
cx            nbins = nbins + nbinsint
          else
             GOTO 236 ! don't do anything
          endif
 1921   ifirst(nchan) = nbins + 1
        nbins = nbins + nbinsint
 236    enddo                     ! ichan=1,3
        if (xtest19x) write (6,*) 'Done with 4 jets ENER=',ener
        enddo ! iener=1,4
      endif

