C-*-FORTRAN-*-
C
c
c 2000 Channels 
c
c Four Jets -- 2B/4B treatment

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        do iebin = 1,n_ebins_2000
          rate(1) = 0.
          rate(2) = 0.
          rate(3) = 0.
          rate(4) = 0.
          rate(5) = 0.
          rate(6) = 0.
          rate(7) = 0.
          rate(8) = 0.
          rate(9) = 0.
          rate(10)= 0.
          do ichan = 1,3
            if (ichan.eq.1) iana = 2
            if (ichan.eq.2) iana = 2
            if (ichan.eq.3) iana = 1
            if ((ichan.eq.1).and.(iopt.eq.1)) then
              nchan = nchan + 1 
              channame(nchan) =
     &          'ALEPH '//ENAME(iebin)//' 4b (opt 1)'
            else if ((ichan.eq.1).and.(iopt.eq.0)) then
              nchan = nchan + 1
              channame(nchan) =
     &          'ALEPH '//ENAME(iebin)//' 4b (auto)'
            else if ((ichan.eq.2).and.(iopt.eq.2)) then
              nchan = nchan + 1 
              channame(nchan) =
     &          'ALEPH '//ENAME(iebin)//' 4b (opt 2)'
            else if (ichan.eq.3) then
              nchan = nchan + 1 
              channame(nchan) =
     &          'ALEPH '//ENAME(iebin)//' 2b'
            endif

c            write(*,*) nchan,channame(nchan)

            ener_max = 199.+0.1*(ihigh_energy(iebin))
            ener_min = 199.+0.1*(ilow_energy(iebin)-1)

c            write(*,*) ener_min,ener_max

c create binned shape info
            if (xtest19x) write (6,*) 'ichan,iopt2',ichan,iopt2
            IF ((ICHAN.EQ.1).and.(iopt2.eq.1)) THEN
C hZ/hA 4b branch, Option 1 (using "hZ shapes": mH and NN)
              xl1 = 40.
              xu1 = ener_max-91.2
              xl2 = -4.0
              xu2 = 0.00005
              nbinsint1 = 100
              nbinsint2 = 100
              nbinsint  = 100

              nerrch(nchan) = 10
              sysname(1,nchan)='A'//ENAME(iebin)//'-4b-mcstat-sig'
              sysname(2,nchan)='A'//ENAME(iebin)//'-4b-mcstat-bkg'
              sysname(3,nchan)='A2000-jetang'
              sysname(4,nchan)='A2000-b-b'
              sysname(5,nchan)='A2000-b-lt'
              sysname(6,nchan)='BLIFE'
              sysname(7,nchan)='BHADCHDECMULT'
              sysname(8,nchan)='BFRAG'
              sysname(9,nchan)='A2000-4b-selvar'
              sysname(10,nchan)='GTOBBCC'

              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.0059
              dsig(7,nchan) = 0.015
              dsig(8,nchan) = 0.014
              dsig(9,nchan) = 0.
              dsig(10,nchan)= 0.

              dback(1,nchan) = 0.
              dback(2,nchan) = 0.
              dback(3,nchan) = 0.
              dback(4,nchan) = 0.
              dback(5,nchan) = 0.
              dback(6,nchan) = 0.
              dback(7,nchan) = 0.
              dback(8,nchan) = 0.
              dback(9,nchan) = 0.
              dback(10,nchan) = 0.

              sigstaterr(1) = 0.
              sigstaterr(2) = 0.

              bkgstaterr(1) = 0.
              bkgstaterr(2) = 0.
              bkgstaterr(3) = 0.

              call a2dzero1(nbinsint1,nbinsint2,sighist2d)
              call a2dzero1(nbinsint1,nbinsint2,hzhist2d)
              call a2dzero1(nbinsint1,nbinsint2,sighist2d2)
              call a2dzero1(nbinsint1,nbinsint2,hzhist2d2)
              call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
              call a2dzero2(nbinsint1,nbinsint2,candhist2d)

              bkgtotal = 0.
              sigtotal = 0.

              do iener = ilow_energy(iebin),ihigh_energy(iebin)
                if (lumi_2000(iener).gt.0.) then

                ener = 199.+ 0.1*(iener-0.5)

c                write(*,*) ener

                xlzh = xsec_interp(1,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlah = xsec_interp(2,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlzh2 = xsec_interp(1,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                xlah2 = xsec_interp(2,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)

c                write(*,*) ener,lumi_2000(iener)
c                write(*,*) xlzh,xlah

                xdouble = mh
                ydouble = mapole
                xdouble2 = mh2
                ydouble2 = mapole2

                ratech = SNGL(A_4j_eff_2000(xdouble,ener,iana,1,1))*
     >                        z0toh*xlzh*bhbb
                ratech2=SNGL(A_4j_eff_2000(xdouble2,ener,iana,1,1))*
     >                        z0toh*xlzh2*bhbb2
                if (xtest19x) write (6,*) '4 jets only',ener,ratech
                rate2ch= SNGL(A_4j_eff_2000((xdouble+ydouble)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb*babb*xlah
                rate2ch2=SNGL(A_4j_eff_2000((xdouble2+ydouble2)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb2*babb2*xlah2

                if (ratech.lt.0.0) ratech=0.0
                if (rate2ch.lt.0.0) rate2ch=0.0

                rate(1) = rate(1) + ratech
                rate(2) = rate(2) + rate2ch

c                write(*,*) 'four jet signal',ratech
c                write(*,*) A_4j_eff_2000(xdouble,ener,iana,1,1),
c     &                     z0toh,xlzh,bhbb
c                write(*,*) ratech,rate2ch

                sigtotal = sigtotal + ratech + rate2ch

c                write(*,*) sigtotal

                sigstaterr(1) = sigstaterr(1) + ratech*0.037
                sigstaterr(2) = sigstaterr(2) + rate2ch*0.016

                dsig(3,nchan) = dsig(3,nchan) + 
     >                          ratech*0.0048 +
     >                          rate2ch*0.0055
                dsig(4,nchan) = dsig(4,nchan) +
     >                          ratech*0.025 +
     >                          rate2ch*0.011


                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >                         xdouble,iana,1,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >                         A_4j_sig_nn_2000,
     >                         xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                       sighist1,sighist2,sighist2d)

                if (iebin.eq.5.and.icorrect.eq.1) then
                  call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                         sighist1,sighist2,hzhist2d)
                endif

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >                         xdouble2,iana,1,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >                         A_4j_sig_nn_2000,
     >                         xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                       sighist1,sighist2,sighist2d2)

                if (iebin.eq.5.and.icorrect.eq.1) then
                  call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                         sighist1,sighist2,hzhist2d2)
                endif

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >               (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >               A_4j_sig_nn_2000,
     >               (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                       sighist1,sighist2,sighist2d)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >               (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >               A_4j_sig_nn_2000,
     >               (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                       sighist1,sighist2,sighist2d2)


c                write(*,*) 'ha shape done'

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist1)
c                write(*,*) 'Mass shape done'
                call abhcreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist2)
c                write(*,*) 'NN shape done'
c QQ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,1)*
     >                     lumi_2000(iener)*
     >                    (al_xsect_dd(ener)+al_xsect_uu(ener)+
     >                     al_xsect_ss(ener)+al_xsect_cc(ener)+
     >                     al_xsect_bb(ener))

                rate(3) = rate(3) + bkglevel
c                write(*,*) '4jet bkg level ',bkglevel
c                write(*,*) A_4j_bkg_2000(ener,iana,1),lumi_2000(iener)
c                write(*,*) 'background level computed'
                bkgtotal = bkgtotal + bkglevel

c                write(*,*) bkglevel,bkgtotal

                bkgstaterr(1) = bkgstaterr(1) + bkglevel*0.134
                dback(3,nchan) = dback(3,nchan) + (bkglevel*0.009)
                dback(5,nchan) = dback(5,nchan) + (bkglevel*0.183)
                dback(6,nchan) = dback(6,nchan) + (bkglevel*0.011)
                dback(7,nchan) = dback(7,nchan) + (bkglevel*0.044)
                dback(8,nchan) = dback(8,nchan) + (bkglevel*0.049)
                dback(10,nchan)= dback(10,nchan)+ (bkglevel*0.075)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist1)
                call abhcreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist2)
c WW bkg
                bkglevel = A_4j_bkg_2000(ener,iana,2)*
     &                     lumi_2000(iener)*
     &                     al_xsect_ww(ener)

                rate(4) = rate(4) + bkglevel
                bkgtotal = bkgtotal + bkglevel

c                write(*,*) bkglevel,bkgtotal

                bkgstaterr(2) = bkgstaterr(2) + bkglevel*0.192
                dback(3,nchan) = dback(3,nchan) + (bkglevel*0.019)
                dback(5,nchan) = dback(5,nchan) + (bkglevel*0.400)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist1)
                call abhcreateE_fancy(xl2,xu2,nbinsint2,-1.05,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist2)
c ZZ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,3)*
     >                     lumi_2000(iener)*
     >                     al_xsect_zz(ener)

                rate(5) = rate(5) + bkglevel

                bkgtotal = bkgtotal + bkglevel

c                write(*,*) bkglevel,bkgtotal

                bkgstaterr(3) = bkgstaterr(3) + bkglevel*0.056
                dback(3,nchan) = dback(3,nchan) +(bkglevel*0.0095)
                dback(4,nchan) = dback(4,nchan) + (bkglevel*0.053)
                dback(6,nchan) = dback(6,nchan) + (bkglevel*0.0063)
                dback(7,nchan) = dback(7,nchan) + (bkglevel*0.018)
                dback(8,nchan) = dback(8,nchan) + (bkglevel*0.015)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

c                write(*,*) '4b background------------'
c                write(*,*) 'qq: ',A_4j_bkg_2000(ener,iana,1),
c     >                            A_4j_bkg_2000(ener,iana,1)*
c     >                           (al_xsect_uu(ener)+
c     >                            al_xsect_dd(ener)+
c     >                            al_xsect_ss(ener)+
c     >                            al_xsect_cc(ener)+
c     >                            al_xsect_bb(ener))
c                write(*,*) 'WW: ',A_4j_bkg_2000(ener,iana,2),
c     >                            A_4j_bkg_2000(ener,iana,2)*
c     >                            al_xsect_ww(ener)
c                write(*,*) 'ZZ: ',A_4j_bkg_2000(ener,iana,3),
c     >                            A_4j_bkg_2000(ener,iana,3)*
c     >                            al_xsect_zz(ener)
                endif
              enddo

              if (sigtotal.gt.0.) then
                dsig(1,nchan) = sqrt(sigstaterr(1)**2
     >                              +sigstaterr(2)**2)/sigtotal
                dsig(3,nchan) = dsig(3,nchan)/sigtotal
                dsig(4,nchan) = dsig(4,nchan)/sigtotal
              else
                dsig(1,nchan) = 0.
                dsig(3,nchan) = 0.
                dsig(4,nchan) = 0.
              endif

              if (bkgtotal.gt.0.) then
                dback(2,nchan) = sqrt(bkgstaterr(1)**2
     >                               +bkgstaterr(2)**2
     >                               +bkgstaterr(3)**2)/bkgtotal
                dback(3,nchan) = dback(3,nchan)/bkgtotal
                dback(4,nchan) = dback(4,nchan)/bkgtotal
                dback(5,nchan) = dback(5,nchan)/bkgtotal
                dback(6,nchan) = dback(6,nchan)/bkgtotal
                dback(7,nchan) = dback(7,nchan)/bkgtotal
                dback(8,nchan) = dback(8,nchan)/bkgtotal
                dback(10,nchan)= dback(10,nchan)/bkgtotal
              else
                dback(2,nchan) = 0.
                dback(3,nchan) = 0.
                dback(4,nchan) = 0.
                dback(5,nchan) = 0.
                dback(6,nchan) = 0.
                dback(7,nchan) = 0.
                dback(8,nchan) = 0.
                dback(10,nchan) = 0.
              endif

              nacand = A_4j_NCAND_2000(iana)
              do i=1,nacand
                ener_cand = A_4j_ecmcand_2000(iana,i)
                candmass = A_4j_MHCAND_2000(iana,i)
                candbtag = A_4j_NNCAND_2000(iana,i)
                if ((ener_cand.ge.ener_min).and.
     &              (ener_cand.lt.ener_max)) then

                  call abin1(candmass,xl1,xu1,
     >                       nbinsint1,ibin1)
                  call abin_fancy(candbtag,xl2,xu2,
     >                       nbinsint2,-1.05,ibin2)
                  if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +              ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +              candhist2d(ibin1,ibin2) =
     +                candhist2d(ibin1,ibin2)+1
                endif
              enddo

              call arebin5(nbinsint1,nbinsint2,
     >                     sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                     nbinsint,sig(nbins+1),
     >                     sig2(nbins+1),backw(nbins+1),
     >                     ncand(nbins+1))

c              write(*,*) 'Total real signal and background'
c              write(*,*) sigtotal,bkgtotal
              sigtotal = 0.
              bkgtotal = 0.
              do isig = 1,nbinsint1
                do ibkg = 1,nbinsint2
                  sigtotal = sigtotal + sighist2d(isig,ibkg)
                  bkgtotal = bkgtotal + bkghist2d(isig,ibkg)
                enddo
              enddo
c              write(*,*) sigtotal,bkgtotal
              sigtotal = 0.
              bkgtotal = 0.
              do isig = nbins+1,nbins+nbinsint
                sigtotal = sigtotal + sig(isig)
                bkgtotal = bkgtotal + backw(isig)
              enddo
c              write(*,*) sigtotal,bkgtotal

c systematics
              if (.not.subbg) then
                call vzero(backg(nbins+1),nbinsint)
              elseif (dosyst) then
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              else
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              endif
              ifirst(nchan) = nbins + 1
              nbins = nbins + nbinsint

C hZ/hA 4b branch, Option 2 (using "hA shapes": Msum and b-tag)

            else if ((ichan.eq.2).and.(iopt2.eq.2)) then
              xl1 = 30.
              xu1 = ener_max
              xl2 = -100.
              xu2 = 272.
              nbinsint1 = 100
              nbinsint2 = 100
              nbinsint  = 100

              nerrch(nchan) = 10
              sysname(1,nchan)='A'//ENAME(iebin)//'-4b-mcstat-sig'
              sysname(2,nchan)='A'//ENAME(iebin)//'-4b-mcstat-bkg'
              sysname(3,nchan)='A2000-jetang'
              sysname(4,nchan)='A2000-b-b'
              sysname(5,nchan)='A2000-b-lt'
              sysname(6,nchan)='BLIFE'
              sysname(7,nchan)='BHADCHDECMULT'
              sysname(8,nchan)='BFRAG'
              sysname(9,nchan)='A2000-4b-selvar'
              sysname(10,nchan)='GTOBBCC'

              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.0059
              dsig(7,nchan) = 0.015
              dsig(8,nchan) = 0.014
              dsig(9,nchan) = 0.
              dsig(10,nchan)= 0.

              dback(1,nchan) = 0.
              dback(2,nchan) = 0.
              dback(3,nchan) = 0.
              dback(4,nchan) = 0.
              dback(5,nchan) = 0.
              dback(6,nchan) = 0.
              dback(7,nchan) = 0.
              dback(8,nchan) = 0.
              dback(9,nchan) = 0.
              dback(10,nchan) = 0.

              sigstaterr(1) = 0.
              sigstaterr(2) = 0.

              bkgstaterr(1) = 0.
              bkgstaterr(2) = 0.
              bkgstaterr(3) = 0.

              call a2dzero1(nbinsint1,nbinsint2,sighist2d)
              call a2dzero1(nbinsint1,nbinsint2,sighist2d2)
              call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
              call a2dzero2(nbinsint1,nbinsint2,candhist2d)

              sigtotal = 0.
              bkgtotal = 0.

              do iener = ilow_energy(iebin),ihigh_energy(iebin)
                if (lumi_2000(iener).gt.0.) then
                ener = 199.+ 0.1*(iener-0.5)

                xlzh = xsec_interp(1,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlah = xsec_interp(2,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlzh2 = xsec_interp(1,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                xlah2 = xsec_interp(2,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)

                xdouble = mh
                ydouble = mapole
                xdouble2 = mh2
                ydouble2 = mapole2
                ratech = SNGL(A_4j_eff_2000(xdouble,ener,iana,1,1))*
     >                        z0toh*xlzh*bhbb
                ratech2=SNGL(A_4j_eff_2000(xdouble2,ener,iana,1,1))*
     >                        z0toh*xlzh2*bhbb2
                if (xtest19x) write (6,*) '4 jets only',ener,ratech
                rate2ch= SNGL(A_4j_eff_2000((xdouble+ydouble)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb*babb*xlah
                rate2ch2=SNGL(A_4j_eff_2000((xdouble2+ydouble2)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb2*babb2*xlah2
                if (ratech.lt.0.0) ratech=0.0
                if (rate2ch.lt.0.0) rate2ch=0.0
                if (ratech2.lt.0.0) ratech2=0.0
                if (rate2ch2.lt.0.0) rate2ch2=0.0

c                write(*,*) 'four jet signal',ratech
c                write(*,*) A_4j_eff_2000(xdouble,ener,iana,2,1),
c     &                     z0toh,xlzh,bhbb
c                write(*,*) ratech,rate2ch

                sigtotal = sigtotal + ratech + rate2ch

                sigstaterr(1) = sigstaterr(1) + ratech*0.037
                sigstaterr(2) = sigstaterr(2) + ratech*0.016

                dsig(3,nchan) = dsig(3,nchan) +
     >                          ratech*0.0048 +
     >                          rate2ch*0.0055
                dsig(4,nchan) = dsig(4,nchan) +
     >                          ratech*0.025  +
     >                          rate2ch*0.011


                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_msum_2000,
     >                         xdouble,iana,1,ener,sighist1)
                call ascreateE(xl2,xu2,nbinsint2,A_4j_sig_fvar_2000,
     >                         xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                       sighist1,sighist2,sighist2d)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_msum_2000,
     >                         xdouble2,iana,1,ener,sighist1)
                call ascreateE(xl2,xu2,nbinsint2,A_4j_sig_fvar_2000,
     >                         xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                       sighist1,sighist2,sighist2d2)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_msum_2000,
     >               (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
                call ascreateE(xl2,xu2,nbinsint2,A_4j_sig_fvar_2000,
     >               (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                       sighist1,sighist2,sighist2d)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_msum_2000,
     >               (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
                call ascreateE(xl2,xu2,nbinsint2,A_4j_sig_fvar_2000,
     >               (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                       sighist1,sighist2,sighist2d2)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_msum_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist1)
                call abhcreateE(xl2,xu2,nbinsint2,A_4j_bkg_fvar_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist2)
c QQ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,1)*
     >                     lumi_2000(iener)*
     >                    (al_xsect_dd(ener)+al_xsect_uu(ener)+
     >                     al_xsect_ss(ener)+al_xsect_cc(ener)+
     >                     al_xsect_bb(ener))
                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(1) = bkgstaterr(1) + bkglevel*0.134
                dback(3,nchan) = dback(4,nchan) + (bkglevel*0.009)
                dback(5,nchan) = dback(6,nchan) + (bkglevel*0.183)
                dback(6,nchan) = dback(7,nchan) + (bkglevel*0.011)
                dback(7,nchan) = dback(8,nchan) + (bkglevel*0.044)
                dback(8,nchan) = dback(9,nchan) + (bkglevel*0.049)
                dback(10,nchan)= dback(12,nchan)+ (bkglevel*0.075)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_msum_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist1)
                call abhcreateE(xl2,xu2,nbinsint2,A_4j_bkg_fvar_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist2)
c WW bkg
                bkglevel = A_4j_bkg_2000(ener,iana,2)*
     >                     lumi_2000(iener)*
     >                     al_xsect_ww(ener)

                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(2) = bkgstaterr(2) + bkglevel*0.192
                dback(3,nchan) = dback(4,nchan) + (bkglevel*0.019)
                dback(5,nchan) = dback(6,nchan) + (bkglevel*0.400)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_msum_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist1)
                call abhcreateE(xl2,xu2,nbinsint2,A_4j_bkg_fvar_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist2)
c ZZ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,3)*
     >                     lumi_2000(iener)*
     >                     al_xsect_zz(ener)
                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(3) = bkgstaterr(3) + bkglevel*0.056
                dback(3,nchan) = dback(4,nchan) + (bkglevel*0.0095)
                dback(4,nchan) = dback(5,nchan) + (bkglevel*0.053)
                dback(6,nchan) = dback(7,nchan) + (bkglevel*0.0063)
                dback(7,nchan) = dback(8,nchan) + (bkglevel*0.018)
                dback(8,nchan) = dback(9,nchan) + (bkglevel*0.015)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                endif
              enddo

              if (sigtotal.gt.0.) then
                dsig(1,nchan) = sqrt(sigstaterr(1)**2
     >                              +sigstaterr(2)**2)/sigtotal
                dsig(3,nchan) = dsig(3,nchan)/sigtotal
                dsig(4,nchan) = dsig(4,nchan)/sigtotal
              else
                dsig(1,nchan) = 0.
                dsig(3,nchan) = 0.
                dsig(4,nchan) = 0.
              endif

              if (bkgtotal.gt.0.) then
                dback(2,nchan) = sqrt(bkgstaterr(1)**2
     >                               +bkgstaterr(2)**2
     >                               +bkgstaterr(3)**2)/bkgtotal
                dback(3,nchan) = dback(3,nchan)/bkgtotal
                dback(4,nchan) = dback(4,nchan)/bkgtotal
                dback(5,nchan) = dback(5,nchan)/bkgtotal
                dback(6,nchan) = dback(6,nchan)/bkgtotal
                dback(7,nchan) = dback(7,nchan)/bkgtotal
                dback(8,nchan) = dback(8,nchan)/bkgtotal
                dback(10,nchan)= dback(10,nchan)/bkgtotal
              else
                dback(2,nchan) = 0.
                dback(3,nchan) = 0.
                dback(4,nchan) = 0.
                dback(5,nchan) = 0.
                dback(6,nchan) = 0.
                dback(7,nchan) = 0.
                dback(8,nchan) = 0.
                dback(10,nchan) = 0.
              endif

              nacand = A_4j_NCAND_2000(iana)
              do i=1,nacand
                ener_cand = A_4j_ecmcand_2000(iana,i)
                candmass = A_4j_MSUMCAND_2000(iana,i)
                candbtag = A_4j_FVARCAND_2000(iana,i)

                if ((ener_cand.ge.ener_min).and.
     &              (ener_cand.lt.ener_max)) then

                  call abin1(candmass,xl1,xu1,
     >                       nbinsint1,ibin1)
                  call abin1(candbtag,xl2,xu2,
     >                       nbinsint2,ibin2)
                  if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +              ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +              candhist2d(ibin1,ibin2) =
     +              candhist2d(ibin1,ibin2)+1
                endif
              enddo

              call arebin5(nbinsint1,nbinsint2,
     >                     sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                     nbinsint,sig(nbins+1),
     >                     sig2(nbins+1),backw(nbins+1),
     >                     ncand(nbins+1))
c systematics
              if (.not.subbg) then
                call vzero(backg(nbins+1),nbinsint)
              elseif (dosyst) then
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              else
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              endif
              ifirst(nchan) = nbins + 1
              nbins = nbins + nbinsint

            ELSE IF (ICHAN.EQ.3) THEN 
              xl1 = 40.
              xu1 = ener_max-91.2
              xl2 = 0.763
              xu2 = 1.000
              nbinsint1 = 100
              nbinsint2 = 100
              nbinsint  = 100

              nerrch(nchan) = 10
              sysname(1,nchan)='A'//ENAME(iebin)//'-2b-mcstat-sig'
              sysname(2,nchan)='A'//ENAME(iebin)//'-2b-mcstat-bkg'
              sysname(3,nchan)='A2000-jetang'
              sysname(4,nchan)='A2000-b-b'
              sysname(5,nchan)='A2000-b-lt'
              sysname(6,nchan)='BLIFE'
              sysname(7,nchan)='BHADCHDECMULT'
              sysname(8,nchan)='BFRAG'
              sysname(9,nchan)='A2000-2b-selvar'
              sysname(10,nchan)='GTOBBCC'

              dsig(1,nchan) = 0.
              dsig(2,nchan) = 0.
              dsig(3,nchan) = 0.
              dsig(4,nchan) = 0.
              dsig(5,nchan) = 0.
              dsig(6,nchan) = 0.0059
              dsig(7,nchan) = 0.015
              dsig(8,nchan) = 0.014
              dsig(9,nchan) = 0.0105
              dsig(10,nchan)= 0.

              dback(1,nchan) = 0.
              dback(2,nchan) = 0.
              dback(3,nchan) = 0.
              dback(4,nchan) = 0.
              dback(5,nchan) = 0.
              dback(6,nchan) = 0.
              dback(7,nchan) = 0.
              dback(8,nchan) = 0.
              dback(9,nchan) = 0.
              dback(10,nchan)= 0.

              sigstaterr(1) = 0.
              sigstaterr(2) = 0.

              bkgstaterr(1) = 0.
              bkgstaterr(2) = 0.
              bkgstaterr(3) = 0.

              call a2dzero1(nbinsint1,nbinsint2,sighist2d)
              call a2dzero1(nbinsint1,nbinsint2,sighist2d2)
              call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
              call a2dzero2(nbinsint1,nbinsint2,candhist2d)

              bkgtotal = 0.
              sigtotal = 0.

              do iener = ilow_energy(iebin),ihigh_energy(iebin)
                if (lumi_2000(iener).gt.0.) then
                ener = 199.+ 0.1*(iener-0.5)

                xlzh = xsec_interp(1,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlah = xsec_interp(2,xsec,sngl(ener))*
     &                 lumi_2000(iener)
                xlzh2 = xsec_interp(1,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                xlah2 = xsec_interp(2,xsec2,sngl(ener))*
     &                 lumi_2000(iener)
                chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)

                xdouble = mh
                ydouble = mapole
                xdouble2 = mh2
                ydouble2 = mapole2
                ratech = SNGL(A_4j_eff_2000(xdouble,ener,iana,1,1))*
     >                        z0toh*xlzh*bhbb
                ratech2=SNGL(A_4j_eff_2000(xdouble2,ener,iana,1,1))*
     >                        z0toh*xlzh2*bhbb2
                if (xtest19x) write (6,*) '4 jets only',ener,ratech
                rate2ch= SNGL(A_4j_eff_2000((xdouble+ydouble)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb*babb*xlah
                rate2ch2=SNGL(A_4j_eff_2000((xdouble2+ydouble2)/2D0,
     >                        ener,iana,2,1))*
     >                        bhbb2*babb2*xlah2
                if (ratech.lt.0.0) ratech=0.0
                if (rate2ch.lt.0.0) rate2ch=0.0

                rate(6) = rate(6) + ratech
                rate(7) = rate(7) + rate2ch

c                write(*,*) 'four jet signal',ratech
c                write(*,*) A_4j_eff_2000(xdouble,ener,iana,1,1),
c     &                     z0toh,xlzh,bhbb
c                write(*,*) ratech,rate2ch

                sigtotal = sigtotal + ratech + rate2ch

                sigstaterr(1) = sigstaterr(1) + ratech*0.018
                sigstaterr(2) = sigstaterr(2) + rate2ch*0.025

                dsig(3,nchan) = dsig(3,nchan) +
     >                          ratech*0.010 +
     >                          rate2ch*0.0065
                dsig(4,nchan) = dsig(4,nchan) +
     >                          ratech*0.00033 +
     >                          rate2ch*0.017

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >                         xdouble,iana,1,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >                         A_4j_sig_nn_2000,
     >                         xdouble,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                       sighist1,sighist2,sighist2d)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >                         xdouble2,iana,1,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >                         A_4j_sig_nn_2000,
     >                         xdouble2,iana,1,ener,sighist2)
c Add together into 2D histogram.
                call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                       sighist1,sighist2,sighist2d2)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >              (xdouble+ydouble)/2D0,iana,2,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >              A_4j_sig_nn_2000,
     >              (xdouble+ydouble)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                       sighist1,sighist2,sighist2d)

                call ascreateE(xl1,xu1,nbinsint1,A_4j_sig_mh_2000,
     >              (xdouble2+ydouble2)/2D0,iana,2,ener,sighist1)
                call ascreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >              A_4j_sig_nn_2000,
     >              (xdouble2+ydouble2)/2D0,iana,2,ener,sighist2)

                call a2dadd1(nbinsint1,nbinsint2,rate2ch2,
     >                       sighist1,sighist2,sighist2d2)


                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist1)
                call abhcreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,1,ener,backhist2)
c QQ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,1)*
     >                     lumi_2000(iener)*
     >                    (al_xsect_dd(ener)+al_xsect_uu(ener)+
     >                     al_xsect_ss(ener)+al_xsect_cc(ener)+
     >                     al_xsect_bb(ener))

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)



                rate(8) = rate(8) + bkglevel

                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(1) = bkgstaterr(1) + bkglevel*0.054
                dback(3,nchan) = dback(3,nchan) + (bkglevel*0.0029)
                dback(5,nchan) = dback(5,nchan) + (bkglevel*0.009)
                dback(6,nchan) = dback(6,nchan) + (bkglevel*0.011)
                dback(7,nchan) = dback(7,nchan) + (bkglevel*0.044)
                dback(8,nchan) = dback(8,nchan) + (bkglevel*0.049)
                dback(9,nchan) = dback(9,nchan) + (bkglevel*0.054)
                dback(10,nchan)= dback(10,nchan)+ (bkglevel*0.075)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist1)
                call abhcreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,2,ener,backhist2)
c WW bkg
                bkglevel = A_4j_bkg_2000(ener,iana,2)*
     >                     lumi_2000(iener)*
     >                     al_xsect_ww(ener)

                rate(9) = rate(9) + bkglevel

                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(2) = bkgstaterr(2) + bkglevel*0.031
                dback(3,nchan) = dback(3,nchan) + (bkglevel*0.016)
                dback(5,nchan) = dback(5,nchan) + (bkglevel*0.056)
                dback(9,nchan) = dback(11,nchan)+ (bkglevel*0.033)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

                call abhcreateE(xl1,xu1,nbinsint1,A_4j_bkg_mh_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist1)
                call abhcreateE_fancy(xl2,xu2,nbinsint2,0.9705,
     >                          A_4j_bkg_nn_2000,
     >                          A_4j_bkg_2000,iana,3,ener,backhist2)
c ZZ bkg
                bkglevel = A_4j_bkg_2000(ener,iana,3)*
     >                     lumi_2000(iener)*
     >                     al_xsect_zz(ener)     

                rate(10) = rate(10) + bkglevel

                bkgtotal = bkgtotal + bkglevel

                bkgstaterr(3) = bkgstaterr(3) + bkglevel*0.025
                dback(3,nchan) = dback(3,nchan) + (bkglevel*0.0049)
                dback(4,nchan) = dback(4,nchan) + (bkglevel*0.0026)
                dback(6,nchan) = dback(6,nchan) + (bkglevel*0.0063)
                dback(7,nchan) = dback(7,nchan) + (bkglevel*0.018)
                dback(8,nchan) = dback(8,nchan) + (bkglevel*0.015)
                dback(9,nchan) = dback(9,nchan) + (bkglevel*0.035)

                call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                       backhist1,backhist2,bkghist2d)

c                write(*,*) '2b background------------'
c                write(*,*) 'qq: ',A_4j_bkg_2000(ener,iana,1),
c     >                            A_4j_bkg_2000(ener,iana,1)*
c     >                           (al_xsect_uu(ener)+
c     >                            al_xsect_dd(ener)+
c     >                            al_xsect_ss(ener)+
c     >                            al_xsect_cc(ener)+
c     >                            al_xsect_bb(ener))
c                write(*,*) 'WW: ',A_4j_bkg_2000(ener,iana,2),
c     >                            A_4j_bkg_2000(ener,iana,2)*
c     >                            al_xsect_ww(ener)
c                write(*,*) 'ZZ: ',A_4j_bkg_2000(ener,iana,3),
c     >                            A_4j_bkg_2000(ener,iana,3)*
c     >                            al_xsect_zz(ener)


                endif
              enddo

              if (sigtotal.gt.0.) then
                dsig(1,nchan) = sqrt(sigstaterr(1)**2
     >                              +sigstaterr(2)**2)/sigtotal
                dsig(3,nchan) = dsig(3,nchan)/sigtotal
                dsig(4,nchan) = dsig(4,nchan)/sigtotal
              else
                dsig(1,nchan) = 0.
                dsig(3,nchan) = 0.
                dsig(4,nchan) = 0.
              endif

              if (bkgtotal.gt.0.) then
                dback(2,nchan) = sqrt(bkgstaterr(1)**2
     >                               +bkgstaterr(2)**2
     >                               +bkgstaterr(3)**2)/bkgtotal
                dback(3,nchan) = dback(3,nchan)/bkgtotal
                dback(4,nchan) = dback(4,nchan)/bkgtotal
                dback(5,nchan) = dback(5,nchan)/bkgtotal
                dback(6,nchan) = dback(6,nchan)/bkgtotal
                dback(7,nchan) = dback(7,nchan)/bkgtotal
                dback(8,nchan) = dback(8,nchan)/bkgtotal
                dback(9,nchan)=  dback(9,nchan)/bkgtotal
                dback(10,nchan)= dback(10,nchan)/bkgtotal
              else
                dback(2,nchan) = 0.
                dback(3,nchan) = 0.
                dback(4,nchan) = 0.
                dback(5,nchan) = 0.
                dback(6,nchan) = 0.
                dback(7,nchan) = 0.
                dback(8,nchan) = 0.
                dback(9,nchan) = 0.
                dback(10,nchan) = 0.
              endif

              nacand = A_4j_NCAND_2000(iana)
              do i=1,nacand
                ener_cand = A_4j_ecmcand_2000(iana,i)
                candmass = A_4j_MHCAND_2000(iana,i)
                candbtag = A_4j_NNCAND_2000(iana,i)
                if ((ener_cand.ge.ener_min).and.
     &              (ener_cand.lt.ener_max)) then

                  call abin1(candmass,xl1,xu1,
     >                       nbinsint1,ibin1)
                  call abin_fancy(candbtag,xl2,xu2,
     >                       nbinsint2,0.9705,ibin2)

                  if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +              ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +              candhist2d(ibin1,ibin2) =
     +              candhist2d(ibin1,ibin2)+1
                endif
              enddo

              call arebin5(nbinsint1,nbinsint2,
     >                     sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                     nbinsint,sig(nbins+1),
     >                     sig2(nbins+1),backw(nbins+1),
     >                     ncand(nbins+1))
c systematics
              if (.not.subbg) then
                call vzero(backg(nbins+1),nbinsint)
              elseif (dosyst) then
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              else
                call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                      nbinsint)
              endif
              ifirst(nchan) = nbins + 1
              nbins = nbins + nbinsint

            endif

          enddo

c          write(*,*) 'Energy bin ',iebin
c          if (rate(6).gt.0.)
c     &      write(*,*) 'signal ',rate(1),rate(6),rate(1)/rate(6)
c          if (rate(8).gt.0.) 
c     &      write(*,*) 'qq bkg ',rate(3),rate(8),rate(3)/rate(8)
c          if (rate(9).gt.0.) 
c     &      write(*,*) 'ww bkg ',rate(4),rate(9),rate(4)/rate(9)
c          if (rate(10).gt.0.) 
c     &      write(*,*) 'zz bkg ',rate(5),rate(10),rate(5)/rate(10)
c          if ((rate(8)+rate(9)+rate(10)).gt.0.)
c     &      write(*,*) 'tot bk ',rate(3)+rate(4)+rate(5),
c     &                           rate(8)+rate(9)+rate(10),
c     &                          (rate(3)+rate(4)+rate(5))/
c     &                          (rate(8)+rate(9)+rate(10))


        if (xtest19x) write (6,*) 'Done with 4 jets ENER=',iebin
        enddo
      endif

