        SUBROUTINE CheckNchan(nchan,maxnchan)
        Implicit none
        Integer nchan,maxnchan
        If (nchan.gt.maxnchan) then
          Print*,
     &'Please enlarge a_maxnchan in a_inputs.inc (>',nchan,')'
          stop
        Endif
        RETURN
        END
        SUBROUTINE CheckNbins(nbins,maxnbin)
        Implicit none
        Integer nbins,maxnbin
        If (nbins.gt.maxnbin) then
          Print*,
     &'Please enlarge a_maxnbin in a_inputs.inc (>',nbins,')'
          stop
        Endif
        RETURN
        END
c! subroutine ahistscal2(nbins,hcont,scale)
c! subroutine ahistscal2 -- scales a 1D histogram so that its integral is
c! the given factor -- change the histogram hcont
c JMP 24/05/2001
      subroutine ahistscal2(nbins,hcont,scale)
      implicit none
      integer nbins,i
      real hcont(*),scale
      real sum,vsum
      external vsum
      sum = 0.0
      do i = 1,nbins
        if (hcont(i).ge.0.) sum = sum + hcont(i)
      enddo
      if (sum.lt.0.0) then
         write(*,*) 'Histogram sum is negative in ahistscal2'
         return
      endif
      if (sum.eq.0.0) then
        do i = 1,nbins
          hcont(i) = 0.0
        enddo
      else
        do i = 1,nbins
          hcont(i) = scale*hcont(i)/sum
        enddo
      endif
      return
      end
      subroutine ascreate10(xl,xh,nbins,func,iener,isig,bhist)
      implicit none
      double precision func
      double precision xd
      external func
      real xl,xh,bhist(*)
      integer nbins,isig,iener
      integer i
      real x,dx
      dx = (xh-xl)/float(nbins)
      do i=1,nbins
        x = xl + (float(i)-0.5)*dx
        xd = x
        bhist(i) = func(xd,iener,isig)
      enddo
      return
      end
