C-*-FORTRAN-*-
C
C This file was prepared by PTD on Fri Feb  4 13:43:12 MET 2000
C This file collects the following inputs:
C
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a192_hll_eff_bb.F
C -rw-r--r--   1 ptd      xu          2486 Feb  2 16:32 a192_hll_eff_other.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a192_hll_eff_tt.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a196_hll_eff_bb.F
C -rw-r--r--   1 ptd      xu          2486 Feb  2 16:32 a196_hll_eff_other.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a196_hll_eff_tt.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a200_hll_eff_bb.F
C -rw-r--r--   1 ptd      xu          2486 Feb  2 16:32 a200_hll_eff_other.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a200_hll_eff_tt.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a202_hll_eff_bb.F
C -rw-r--r--   1 ptd      xu          2486 Feb  2 16:32 a202_hll_eff_other.F
C -rw-r--r--   1 ptd      xu          2480 Feb  2 16:32 a202_hll_eff_tt.F
C
C 
C---- New file --- 
C 
      real*8 FUNCTION a192_hll_eff_bb(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8252, 0.8401, 0.8442, 0.8452, 0.8391,
     &           0.8404, 0.8356, 0.8382, 0.7678, 0.4322,
     &           0.3070, 0.1623, 0.0202, 0.0044 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a192_hll_eff_bb = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a192_hll_eff_other(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8145, 0.8277, 0.8268, 0.8121, 0.8278,
     &           0.8319, 0.8461, 0.8209, 0.7413, 0.4231,
     &           0.3179, 0.1768, 0.0397, 0.0127 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a192_hll_eff_other = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a192_hll_eff_tt(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.5692, 0.5649, 0.5774, 0.5982, 0.6384,
     &           0.5992, 0.6281, 0.6450, 0.5812, 0.3596,
     &           0.2069, 0.1491, 0.0425, 0.0414 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a192_hll_eff_tt = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a196_hll_eff_bb(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8115, 0.8337, 0.8432, 0.8520, 0.8445,
     &           0.8468, 0.8453, 0.8384, 0.8220, 0.6998,
     &           0.5571, 0.3587, 0.1131, 0.0123 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a196_hll_eff_bb = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a196_hll_eff_other(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.7624, 0.8212, 0.8314, 0.8302, 0.8292,
     &           0.8482, 0.8084, 0.8247, 0.7713, 0.6821,
     &           0.5615, 0.3676, 0.1381, 0.0320 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a196_hll_eff_other = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a196_hll_eff_tt(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.5401, 0.5984, 0.6172, 0.5868, 0.5823,
     &           0.6195, 0.6302, 0.6429, 0.6200, 0.5400,
     &           0.4273, 0.2798, 0.0954, 0.0512 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a196_hll_eff_tt = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a200_hll_eff_bb(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8068, 0.8364, 0.8429, 0.8455, 0.8505,
     &           0.8486, 0.8403, 0.8439, 0.8389, 0.8137,
     &           0.7896, 0.6137, 0.2945, 0.0729 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a200_hll_eff_bb = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a200_hll_eff_other(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.7865, 0.8151, 0.8181, 0.8453, 0.8277,
     &           0.8180, 0.8396, 0.8200, 0.8187, 0.8098,
     &           0.7584, 0.5833, 0.3076, 0.0964 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a200_hll_eff_other = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a200_hll_eff_tt(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.5687, 0.5330, 0.5992, 0.5798, 0.6227,
     &           0.5712, 0.6136, 0.6074, 0.6309, 0.6555,
     &           0.6105, 0.4704, 0.2630, 0.0643 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a200_hll_eff_tt = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a202_hll_eff_bb(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8069, 0.8330, 0.8345, 0.8400, 0.8465,
     &           0.8446, 0.8366, 0.8439, 0.8371, 0.8283,
     &           0.8087, 0.7568, 0.4110, 0.1186 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a202_hll_eff_bb = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a202_hll_eff_other(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.8057, 0.8384, 0.8059, 0.8242, 0.8250,
     &           0.8622, 0.8370, 0.8191, 0.7872, 0.8145,
     &           0.8031, 0.7394, 0.4277, 0.1404 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a202_hll_eff_other = m*higgsmss + b
      
      return
      end


C 
C---- New file --- 
C 
      real*8 FUNCTION a202_hll_eff_tt(higgsmss)

      implicit none

      real*8 higgsmss
      real*8 m, b, eff(14), mass(14)

      data eff / 0.5777, 0.5062, 0.5729, 0.5959, 0.6013,
     &           0.6464, 0.6304, 0.6416, 0.6330, 0.6437,
     &           0.6718, 0.6092, 0.3445, 0.0958 /

      data mass / 60.0, 65.0, 70.0, 75.0, 80.0, 85.0, 90.0,
     &            95.0, 100.0, 105.0, 107.0, 110.0, 115.0, 120.0 /

      m = 0.d0
      b = 0.d0

      if ((higgsmss.ge.mass(1)).and.(higgsmss.le.mass(2))) then
        m = (eff(2) - eff(1))/(mass(2)-mass(1))
        b = eff(1) - m*mass(1)
      elseif ((higgsmss.ge.mass(2)).and.(higgsmss.le.mass(3))) then
        m = (eff(3) - eff(2))/(mass(3)-mass(2))
        b = eff(2) - m*mass(2)
      elseif ((higgsmss.ge.mass(3)).and.(higgsmss.le.mass(4))) then
        m = (eff(4) - eff(3))/(mass(4)-mass(3))
        b = eff(3) - m*mass(3)
      elseif ((higgsmss.ge.mass(4)).and.(higgsmss.le.mass(5))) then
        m = (eff(5) - eff(4))/(mass(5)-mass(4))
        b = eff(4) - m*mass(4)
      elseif ((higgsmss.ge.mass(5)).and.(higgsmss.le.mass(6))) then
        m = (eff(6) - eff(5))/(mass(6)-mass(5))
        b = eff(5) - m*mass(5)
      elseif ((higgsmss.ge.mass(6)).and.(higgsmss.le.mass(7))) then
        m = (eff(7) - eff(6))/(mass(7)-mass(6))
        b = eff(6) - m*mass(6)
      elseif ((higgsmss.ge.mass(7)).and.(higgsmss.le.mass(8))) then
        m = (eff(8) - eff(7))/(mass(8)-mass(7))
        b = eff(7) - m*mass(7)
      elseif ((higgsmss.ge.mass(8)).and.(higgsmss.le.mass(9))) then
        m = (eff(9) - eff(8))/(mass(9)-mass(8))
        b = eff(8) - m*mass(8)
      elseif ((higgsmss.ge.mass(9)).and.(higgsmss.le.mass(10))) then
        m = (eff(10) - eff(9))/(mass(10)-mass(9))
        b = eff(9) - m*mass(9)
      elseif ((higgsmss.ge.mass(10)).and.(higgsmss.le.mass(11))) then
        m = (eff(11) - eff(10))/(mass(11)-mass(10))
        b = eff(10) - m*mass(10)
      elseif ((higgsmss.ge.mass(11)).and.(higgsmss.le.mass(12))) then
        m = (eff(12) - eff(11))/(mass(12)-mass(11))
        b = eff(11) - m*mass(11)
      elseif ((higgsmss.ge.mass(12)).and.(higgsmss.le.mass(13))) then
        m = (eff(13) - eff(12))/(mass(13)-mass(12))
        b = eff(12) - m*mass(12)
      elseif ((higgsmss.ge.mass(13)).and.(higgsmss.le.mass(14))) then
        m = (eff(14) - eff(13))/(mass(14)-mass(13))
        b = eff(13) - m*mass(13)
      endif

      a202_hll_eff_tt = m*higgsmss + b
      
      return
      end


