C-*-FORTRAN-*-
C
c
c 192-202 Channels 
c
c Missing Energy -- three analyses

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
         do iener = 1,4
           if (iener.eq.1) ener = 191.6
           if (iener.eq.2) ener = 195.5
           if (iener.eq.3) ener = 199.5
           if (iener.eq.4) ener = 201.6
         do iana=1,3
            nchan = nchan + 1 
            if (iener.eq.1) then
              if (iana.eq.1) then
                 channame(nchan) = 'ALEPH 191.6 Hnn overlap'
              else if (iana.eq.2) then
                 channame(nchan) = 'ALEPH 191.6 Hnn wisc only'
              else if (iana.eq.3) then
                 channame(nchan) = 'ALEPH 191.6 Hnn ors only'
              endif
            else if (iener.eq.2) then
              if (iana.eq.1) then
                 channame(nchan) = 'ALEPH 195.5 Hnn overlap'
              else if (iana.eq.2) then
                 channame(nchan) = 'ALEPH 195.5 Hnn wisc only'
              else if (iana.eq.3) then
                 channame(nchan) = 'ALEPH 195.5 Hnn ors only'
              endif
            else if (iener.eq.3) then
              if (iana.eq.1) then
                 channame(nchan) = 'ALEPH 199.5 Hnn overlap'
              else if (iana.eq.2) then
                 channame(nchan) = 'ALEPH 199.5 Hnn wisc only'
              else if (iana.eq.3) then
                 channame(nchan) = 'ALEPH 199.5 Hnn ors only'
              endif
            else if (iener.eq.4) then
              if (iana.eq.1) then
                 channame(nchan) = 'ALEPH 201.6 Hnn overlap'
              else if (iana.eq.2) then
                 channame(nchan) = 'ALEPH 201.6 Hnn wisc only'
              else if (iana.eq.3) then
                 channame(nchan) = 'ALEPH 201.6 Hnn ors only'
              endif
            endif            
            xlzh = xhz(15+iener)*ah0_lumi(iener+2)
            xlww = xhnunu(15+iener)*ah0_lumi(iener+2)
            xlzh2 = xhz2(15+iener)*ah0_lumi(iener+2)
            xlww2 = xhnunu2(15+iener)*ah0_lumi(iener+2)
            chanlumi(nchan) = ah0_lumi(iener+2)
            IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1922 ! NEXT CHANNEL

            xdouble = mh
            xdouble2 = mh2

            ratech = z0tonn*2./3.*xlzh*
     >           (A_NN_HZ_EFF(ener,iana,1,xdouble)*bhbb)
            rate2ch = xlww*
     >           (A_NN_nuenue_EFF(ener,iana,1,xdouble)*bhbb)
            ratech2 = z0tonn*2./3.*xlzh2*
     >           (A_NN_HZ_EFF(ener,iana,1,xdouble2)*bhbb2)
            rate2ch2 = xlww2*
     >           (A_NN_nuenue_EFF(ener,iana,1,xdouble2)*bhbb2)

            if (xtest19x) then
               write (6,*) 'HNN eff at ',ener,':'
               write (6,*) (A_NN_HZ_EFF(ener,iana,1,xdouble))
            end if
            if (ratech.lt.0.0) ratech=0.0
            if (rate2ch.lt.0.0) rate2ch=0.0
            if (ratech2.lt.0.0) ratech2=0.0
            if (rate2ch2.lt.0.0) rate2ch2=0.0
c     create binned shape info
            xl1 = 50.
            xu1 = ener-91.2
            nbinsint = 100
            aux(1) = ratech + rate2ch
            nerrch(nchan) = 15
            
            if (iener.eq.1) then
              if (iana.eq.1) then
                sysname(1,nchan) = 'A192-NN-OV-E12-SIG'
                sysname(2,nchan) = 'A192-NN-OV-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A192-NN-OV-ETAU-SIG'
                sysname(10,nchan)= 'A192-NN-OV-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A192-NN-OV-MC-SIG'
                sysname(13,nchan)= 'A192-NN-OV-MC-BKG'
                sysname(14,nchan)= 'A192-NN-OV-JET-SIG'
                sysname(15,nchan)= 'A192-NN-OV-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.011)**2 +
     >                                  (rate2ch*0.010)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.004) +
     >                                  (rate2ch*0.002)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.034)**2 +
     >                                  (rate2ch*0.053)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.001)**2 +
     >                                  (rate2ch*0.001)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.2) then
                sysname(1,nchan) = 'A192-NN-WI-E12-SIG'
                sysname(2,nchan) = 'A192-NN-WI-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A192-NN-WI-ETAU-SIG'
                sysname(10,nchan)= 'A192-NN-WI-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A192-NN-WI-MC-SIG'
                sysname(13,nchan)= 'A192-NN-WI-MC-BKG'
                sysname(14,nchan)= 'A192-NN-WI-JET-SIG'
                sysname(15,nchan)= 'A192-NN-WI-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.013)**2 +
     >                                  (rate2ch*0.013)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.001) +
     >                                  (rate2ch*0.000)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= -0.01
                  dsig(12,nchan)= sqrt( (ratech*0.049)**2 +
     >                                  (rate2ch*0.027)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.001)**2 +
     >                                  (rate2ch*0.003)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.3) then
                sysname(1,nchan) = 'A192-NN-OR-E12-SIG'
                sysname(2,nchan) = 'A192-NN-OR-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A192-NN-OR-ETAU-SIG'
                sysname(10,nchan)= 'A192-NN-OR-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A192-NN-OR-MC-SIG'
                sysname(13,nchan)= 'A192-NN-OR-MC-BKG'
                sysname(14,nchan)= 'A192-NN-OR-JET-SIG'
                sysname(15,nchan)= 'A192-NN-OR-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.028)**2 +
     >                                  (rate2ch*0.019)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.003) +
     >                                  (rate2ch*0.003)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.152)**2 +
     >                                  (rate2ch*0.099)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.006)**2 +
     >                                  (rate2ch*0.011)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              endif
            else if (iener.eq.2) then
              if (iana.eq.1) then
                sysname(1,nchan) = 'A196-NN-OV-E12-SIG'
                sysname(2,nchan) = 'A196-NN-OV-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A196-NN-OV-ETAU-SIG'
                sysname(10,nchan)= 'A196-NN-OV-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A196-NN-OV-MC-SIG'
                sysname(13,nchan)= 'A196-NN-OV-MC-BKG'
                sysname(14,nchan)= 'A196-NN-OV-JET-SIG'
                sysname(15,nchan)= 'A196-NN-OV-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.008)**2 +
     >                                  (rate2ch*0.010)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.003) +
     >                                  (rate2ch*0.003)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.042)**2 +
     >                                  (rate2ch*0.030)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.000)**2 +
     >                                  (rate2ch*0.002)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.2) then
                sysname(1,nchan) = 'A196-NN-WI-E12-SIG'
                sysname(2,nchan) = 'A196-NN-WI-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A196-NN-WI-ETAU-SIG'
                sysname(10,nchan)= 'A196-NN-WI-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A196-NN-WI-MC-SIG'
                sysname(13,nchan)= 'A196-NN-WI-MC-BKG'
                sysname(14,nchan)= 'A196-NN-WI-JET-SIG'
                sysname(15,nchan)= 'A196-NN-WI-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.013)**2 +
     >                                  (rate2ch*0.009)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.001) +
     >                                  (rate2ch*0.000)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= -0.01
                  dsig(12,nchan)= sqrt( (ratech*0.046)**2 +
     >                                  (rate2ch*0.028)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.000)**2 +
     >                                  (rate2ch*0.001)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.3) then
                sysname(1,nchan) = 'A196-NN-OR-E12-SIG'
                sysname(2,nchan) = 'A196-NN-OR-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A196-NN-OR-ETAU-SIG'
                sysname(10,nchan)= 'A196-NN-OR-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A196-NN-OR-MC-SIG'
                sysname(13,nchan)= 'A196-NN-OR-MC-BKG'
                sysname(14,nchan)= 'A196-NN-OR-JET-SIG'
                sysname(15,nchan)= 'A196-NN-OR-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.018)**2 +
     >                                  (rate2ch*0.021)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.003) +
     >                                  (rate2ch*0.003)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.110)**2 +
     >                                  (rate2ch*0.082)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.004)**2 +
     >                                  (rate2ch*0.000)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              endif
            else if (iener.eq.3) then
              if (iana.eq.1) then
                sysname(1,nchan) = 'A200-NN-OV-E12-SIG'
                sysname(2,nchan) = 'A200-NN-OV-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A200-NN-OV-ETAU-SIG'
                sysname(10,nchan)= 'A200-NN-OV-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A200-NN-OV-MC-SIG'
                sysname(13,nchan)= 'A200-NN-OV-MC-BKG'
                sysname(14,nchan)= 'A200-NN-OV-JET-SIG'
                sysname(15,nchan)= 'A200-NN-OV-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.008)**2 +
     >                                  (rate2ch*0.008)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.003) +
     >                                  (rate2ch*0.003)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.027)**2 +
     >                                  (rate2ch*0.030)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.002)**2 +
     >                                  (rate2ch*0.001)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.2) then
                sysname(1,nchan) = 'A200-NN-WI-E12-SIG'
                sysname(2,nchan) = 'A200-NN-WI-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A200-NN-WI-ETAU-SIG'
                sysname(10,nchan)= 'A200-NN-WI-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A200-NN-WI-MC-SIG'
                sysname(13,nchan)= 'A200-NN-WI-MC-BKG'
                sysname(14,nchan)= 'A200-NN-WI-JET-SIG'
                sysname(15,nchan)= 'A200-NN-WI-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.010)**2 +
     >                                  (rate2ch*0.009)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.001) +
     >                                  (rate2ch*0.000)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= -0.01
                  dsig(12,nchan)= sqrt( (ratech*0.043)**2 +
     >                                  (rate2ch*0.037)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.001)**2 +
     >                                  (rate2ch*0.004)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.3) then
                sysname(1,nchan) = 'A200-NN-OR-E12-SIG'
                sysname(2,nchan) = 'A200-NN-OR-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A200-NN-OR-ETAU-SIG'
                sysname(10,nchan)= 'A200-NN-OR-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A200-NN-OR-MC-SIG'
                sysname(13,nchan)= 'A200-NN-OR-MC-BKG'
                sysname(14,nchan)= 'A200-NN-OR-JET-SIG'
                sysname(15,nchan)= 'A200-NN-OR-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.022)**2 +
     >                                  (rate2ch*0.022)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.006) +
     >                                  (rate2ch*0.004)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.070)**2 +
     >                                  (rate2ch*0.072)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.001)**2 +
     >                                  (rate2ch*0.000)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              endif
            else if (iener.eq.4) then
              if (iana.eq.1) then
                sysname(1,nchan) = 'A202-NN-OV-E12-SIG'
                sysname(2,nchan) = 'A202-NN-OV-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A202-NN-OV-ETAU-SIG'
                sysname(10,nchan)= 'A202-NN-OV-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A202-NN-OV-MC-SIG'
                sysname(13,nchan)= 'A202-NN-OV-MC-BKG'
                sysname(14,nchan)= 'A202-NN-OV-JET-SIG'
                sysname(15,nchan)= 'A202-NN-OV-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.006)**2 +
     >                                  (rate2ch*0.006)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.003) +
     >                                  (rate2ch*0.003)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.024)**2 +
     >                                  (rate2ch*0.029)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.003)**2 +
     >                                  (rate2ch*0.003)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.2) then
                sysname(1,nchan) = 'A202-NN-WI-E12-SIG'
                sysname(2,nchan) = 'A202-NN-WI-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A202-NN-WI-ETAU-SIG'
                sysname(10,nchan)= 'A202-NN-WI-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A202-NN-WI-MC-SIG'
                sysname(13,nchan)= 'A202-NN-WI-MC-BKG'
                sysname(14,nchan)= 'A202-NN-WI-JET-SIG'
                sysname(15,nchan)= 'A202-NN-WI-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.007)**2 +
     >                                  (rate2ch*0.007)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.001) +
     >                                  (rate2ch*0.000)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= -0.01
                  dsig(12,nchan)= sqrt( (ratech*0.043)**2 +
     >                                  (rate2ch*0.040)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.001)**2 +
     >                                  (rate2ch*0.000)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              else if (iana.eq.3) then
                sysname(1,nchan) = 'A202-NN-OR-E12-SIG'
                sysname(2,nchan) = 'A202-NN-OR-E12-BKG'
                sysname(3,nchan) = 'A19X-BSMR-BB'
                sysname(4,nchan) = 'A19X-BSMR-LT'
                sysname(5,nchan) = 'WWXSECT'
                sysname(6,nchan) = 'ZZXSECT'
                sysname(7,nchan) = 'A19X-NN-QQXSECT'
                sysname(8,nchan) = 'A19X-ISR'
                sysname(9,nchan) = 'A202-NN-OR-ETAU-SIG'
                sysname(10,nchan)= 'A202-NN-OR-ETAU-BKG'
                sysname(11,nchan)= 'A19X-ILPE'
                sysname(12,nchan)= 'A202-NN-OR-MC-SIG'
                sysname(13,nchan)= 'A202-NN-OR-MC-BKG'
                sysname(14,nchan)= 'A202-NN-OR-JET-SIG'
                sysname(15,nchan)= 'A202-NN-OR-JET-BKG'
                if (aux(1).ne.0.) then
                  dsig(1,nchan) = sqrt( (ratech*0.018)**2 +
     >                                  (rate2ch*0.017)**2 )/
     >                                (ratech+rate2ch)
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) =     ( (ratech*0.006) +
     >                                  (rate2ch*0.004)    )/
     >                                (ratech+rate2ch)
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.019
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.01
                  dsig(12,nchan)= sqrt( (ratech*0.059)**2 +
     >                                  (rate2ch*0.070)**2 )/
     >                                (ratech+rate2ch)
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= sqrt( (ratech*0.005)**2 +
     >                                  (rate2ch*0.001)**2 )/
     >                                (ratech+rate2ch)
                  dsig(15,nchan)= 0.
                else
                  dsig(1,nchan) = 0.
                  dsig(2,nchan) = 0.
                  dsig(3,nchan) = 0.
                  dsig(4,nchan) = 0.
                  dsig(5,nchan) = 0.
                  dsig(6,nchan) = 0.
                  dsig(7,nchan) = 0.
                  dsig(8,nchan) = 0.
                  dsig(9,nchan) = 0.
                  dsig(10,nchan)= 0.
                  dsig(11,nchan)= 0.
                  dsig(12,nchan)= 0.
                  dsig(13,nchan)= 0.
                  dsig(14,nchan)= 0.
                  dsig(15,nchan)= 0.
                endif
              endif
            endif

            call ascreateC(xl1,xu1,nbinsint,A_NN_MASS_SIG,
     >           xdouble,iana,ener,sighist1)
            call ahistscal1(nbinsint,sighist1,sighist1s,
     >           ratech)
            
            call ascreateC(xl1,xu1,nbinsint,A_NN_nuenue_MASS_SIG,
     >           xdouble,iana,ener,sighist2)
            call ahistscal1(nbinsint,sighist2,sighist2s,
     >           rate2ch)
            
            call amerge2(nbinsint,sighist1s,sighist2s,sig(nbins+1))

            call ascreateC(xl1,xu1,nbinsint,A_NN_MASS_SIG,
     >           xdouble2,iana,ener,sighist1)
            call ahistscal1(nbinsint,sighist1,sighist1s,
     >           ratech2)
            
            call ascreateC(xl1,xu1,nbinsint,A_NN_nuenue_MASS_SIG,
     >           xdouble2,iana,ener,sighist2)
            call ahistscal1(nbinsint,sighist2,sighist2s,
     >           rate2ch2)
            
            call amerge2(nbinsint,sighist1s,sighist2s,sig2(nbins+1))

            call abhcreateC(xl1,xu1,nbinsint,
     >           A_NN_MASS_BKG,
     >           A_NN_BKG,iana,1,ener,backqq)
            call abhcreateC(xl1,xu1,nbinsint,
     >           A_NN_MASS_BKG,
     >           A_NN_BKG,iana,2,ener,backww)
            call abhcreateC(xl1,xu1,nbinsint,
     >           A_NN_MASS_BKG,
     >           A_NN_BKG,iana,3,ener,backzz)

            do i = 1,nbinsint
              backqq(i) = backqq(i)*ah0_lumi(iener+2)
              backww(i) = backww(i)*ah0_lumi(iener+2)
              backzz(i) = backzz(i)*ah0_lumi(iener+2)
            enddo

            call amerge3(nbinsint,backzz,backww,backqq,backw(nbins+1))

            call vzero(aux,10)
            do i=1,nbinsint
              aux(1) = aux(1) + backqq(i)
              aux(2) = aux(2) + backww(i)
              aux(3) = aux(3) + backzz(i)
              aux(4) = aux(4) + backw(nbins+i)
              aux(5) = aux(5) + sig(nbins+i)
            end do
            if (xtest19x) then
               write (6,*) 'Hnn IANA, bkg(qq,ww,zz,tot), sig:',
     +              ener,iana,(aux(i),i=1,5)
            end if              ! xtest19x

            if (iener.eq.1) then
              if (iana.eq.1) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.043)**2 +
     >                                 (aux(3)*0.023)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.006/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.000)    +
     >                                 (aux(2)*0.064)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.250)**2 +
     >                                 (aux(2)*0.280)**2 +
     >                                 (aux(3)*0.056)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.003)**2 )/aux(4)
              else if (iana.eq.2) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.024)**2 +
     >                                 (aux(2)*0.004)**2 +
     >                                 (aux(3)*0.005)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.018/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.043)    +
     >                                 (aux(2)*0.060)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= -0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.224)**2 +
     >                                 (aux(2)*0.114)**2 +
     >                                 (aux(3)*0.069)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.063)**2 +
     >                                 (aux(3)*0.008)**2 )/aux(4)
              else if (iana.eq.3) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.025)**2 +
     >                                 (aux(2)*0.142)**2 +
     >                                 (aux(3)*0.033)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.015/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.007)    +
     >                                 (aux(2)*0.126)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.162)**2 +
     >                                 (aux(2)*0.514)**2 +
     >                                 (aux(3)*0.136)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.014)**2 +
     >                                 (aux(2)*0.087)**2 +
     >                                 (aux(3)*0.003)**2 )/aux(4)
              endif
            else if (iener.eq.2) then
              if (iana.eq.1) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.006)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.006/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.000)    +
     >                                 (aux(2)*0.064)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.378)**2 +
     >                                 (aux(2)*0.299)**2 +
     >                                 (aux(3)*0.045)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.004)**2 )/aux(4)
              else if (iana.eq.2) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.033)**2 +
     >                                 (aux(2)*0.010)**2 +
     >                                 (aux(3)*0.018)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.018/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.043)    +
     >                                 (aux(2)*0.060)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= -0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.267)**2 +
     >                                 (aux(2)*0.112)**2 +
     >                                 (aux(3)*0.042)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.080)**2 +
     >                                 (aux(2)*0.029)**2 +
     >                                 (aux(3)*0.009)**2 )/aux(4)
              else if (iana.eq.3) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.000)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.015/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.007)    +
     >                                 (aux(2)*0.126)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.171)**2 +
     >                                 (aux(2)*0.395)**2 +
     >                                 (aux(3)*0.102)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.001)**2 +
     >                                 (aux(2)*0.028)**2 +
     >                                 (aux(3)*0.012)**2 )/aux(4)
              endif
            else if (iener.eq.3) then
              if (iana.eq.1) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.007)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.004/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.029)    +
     >                                 (aux(2)*0.045)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.229)**2 +
     >                                 (aux(2)*0.236)**2 +
     >                                 (aux(3)*0.080)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.095)**2 +
     >                                 (aux(2)*0.062)**2 +
     >                                 (aux(3)*0.003)**2 )/aux(4)
              else if (iana.eq.2) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.059)**2 +
     >                                 (aux(2)*0.017)**2 +
     >                                 (aux(3)*0.010)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.007/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.023)    +
     >                                 (aux(2)*0.054)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= -0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.258)**2 +
     >                                 (aux(2)*0.131)**2 +
     >                                 (aux(3)*0.053)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.066)**2 +
     >                                 (aux(2)*0.026)**2 +
     >                                 (aux(3)*0.007)**2 )/aux(4)
              else if (iana.eq.3) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.016)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.007/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.008)    +
     >                                 (aux(2)*0.152)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.141)**2 +
     >                                 (aux(2)*0.500)**2 +
     >                                 (aux(3)*0.168)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.010)**2 +
     >                                 (aux(2)*0.251)**2 +
     >                                 (aux(3)*0.015)**2 )/aux(4)
              endif
            else if (iener.eq.4) then
              if (iana.eq.1) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.000)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.004/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.029)    +
     >                                 (aux(2)*0.045)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.289)**2 +
     >                                 (aux(2)*0.300)**2 +
     >                                 (aux(3)*0.103)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.045)**2 +
     >                                 (aux(2)*0.051)**2 +
     >                                 (aux(3)*0.028)**2 )/aux(4)
              else if (iana.eq.2) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.000)**2 +
     >                                 (aux(2)*0.009)**2 +
     >                                 (aux(3)*0.004)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.007/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.008)    +
     >                                 (aux(2)*0.152)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= -0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.224)**2 +
     >                                 (aux(2)*0.099)**2 +
     >                                 (aux(3)*0.052)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.302)**2 +
     >                                 (aux(2)*0.071)**2 +
     >                                 (aux(3)*0.009)**2 )/aux(4)
              else if (iana.eq.3) then
                dback(1,nchan) = 0.
                dback(2,nchan) = sqrt( (aux(1)*0.028)**2 +
     >                                 (aux(2)*0.000)**2 +
     >                                 (aux(3)*0.000)**2 )/aux(4)
                dback(3,nchan) = aux(3)*0.007/aux(4)
                dback(4,nchan) =     ( (aux(1)*0.008)    +
     >                                 (aux(2)*0.152)    )/aux(4)
                dback(5,nchan) = aux(2)*0.02/aux(4)
                dback(6,nchan) = aux(3)*0.02/aux(4)
                dback(7,nchan) = aux(1)*0.06/aux(4)
                dback(8,nchan) = aux(1)*0.15/aux(4)
                dback(9,nchan) = 0.
                dback(10,nchan)= 0.019
                dback(11,nchan)= 0.010
                dback(12,nchan)= 0.
                dback(13,nchan)= sqrt( (aux(1)*0.171)**2 +
     >                                 (aux(2)*0.302)**2 +
     >                                 (aux(3)*0.179)**2 )/aux(4)
                dback(14,nchan)= 0.
                dback(15,nchan)= sqrt( (aux(1)*0.031)**2 +
     >                                 (aux(2)*0.151)**2 +
     >                                 (aux(3)*0.018)**2 )/aux(4)
              endif
            endif
            
            nacand = A_NN_NCAND(ener,iana)
            do i=1,nacand
               candmass = A_NN_MASS_CAND(ener,iana,i)
               call abin1(candmass,xl1,xu1,
     >              nbinsint,ibin)
               if (ibin.gt.0.and.ibin.le.nbinsint) then
                  ncand(nbins+ibin) = ncand(nbins+ibin) + 1
               endif
            enddo
            
c     systematics
            if (.not.subbg) then
               call vzero(backg(nbins+1),nbinsint)
            elseif (dosyst) then
               call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
            else
               call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
            endif
 1922       ifirst(nchan) = nbins + 1
            nbins = nbins + nbinsint
         enddo                  ! (iana)
      end do                    ! iener
      endif                     ! (switch)
