C-*-FORTRAN-*-
C
c
c 2000 Channels 
c
c Four Jets -- 2B/4B treatment

      switch = .true.
      dosyst = .true.
      subbg = .true.
      if (switch) then
        do iebin = 1,n_ebins_2000
          nchan = nchan + 1
          channame(nchan) =
     &          'ALEPH '//ENAME(iebin)//' Hnn'

          ener_max = 199.+0.1*(ihigh_energy(iebin))
          ener_min = 199.+0.1*(ilow_energy(iebin)-1)

c create binned shape info
          xl1 = 50.
          xu1 = ener_max-91.2
          xl2 = 0.
          xu2 = 1.000

          nbinsint1 = 100
          nbinsint2 = 100
          nbinsint  = 100

          nerrch(nchan) = 8
          sysname(1,nchan)='A2000-hnn-e12'
          sysname(2,nchan)='WWXSECT'
          sysname(3,nchan)='ZZXSECT'
          sysname(4,nchan)='A20x-ISR'
          sysname(5,nchan)='A-hnn-selvars'
          sysname(6,nchan)='A'//ENAME(iebin)//'-hnn-mc-sig'
          sysname(7,nchan)='A'//ENAME(iebin)//'-hnn-mc-bkg'
          sysname(8,nchan)='A2000-jetang'

          dsig(1,nchan) = 0.014
          dsig(2,nchan) = 0.
          dsig(3,nchan) = 0.
          dsig(4,nchan) = 0.
          dsig(5,nchan) = 0.02
          dsig(6,nchan) = 0.
          dsig(7,nchan) = 0.
          dsig(8,nchan) = 0.003

          dback(1,nchan) = 0.
          dback(2,nchan) = 0.
          dback(3,nchan) = 0.
          dback(4,nchan) = 0.
          dback(5,nchan) = 0.02
          dback(6,nchan) = 0.
          dback(7,nchan) = 0.
          dback(8,nchan) = 0.

          call a2dzero1(nbinsint1,nbinsint2,sighist2d)
          call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
          call a2dzero2(nbinsint1,nbinsint2,candhist2d)

          bkgtotal = 0.
          sigtotal = 0.

          sigstat(1) = 0.029
          sigstat(2) = 0.
          sigstat(3) = 0.136
          sigstat(4) = 0.090
          sigstat(5) = 0.134
          sigstat(6) = 0.025
          sigstat(7) = 0.
          sigstat(8) = 0.122
          sigstat(9) = 0.097
          sigstat(10)= 0.125
          
          do isig = 1,10
            sigstaterr(isig) = 0.
          enddo

          bkgstat(1) = 0.204
          bkgstat(2) = 0.277
          bkgstat(3) = 0.333
          bkgstat(4) = 0.288
          bkgstat(5) = 0.447
          bkgstat(6) = 0.042
          bkgstat(7) = 0.025
          bkgstat(8) = 0.031
          bkgstat(9) = 0.710
          bkgstat(10)= 0.014

          do ibkg = 1,10
            bkge12err(ibkg) = 0.
            bkgwwxerr(ibkg) = 0.
            bkgzzxerr(ibkg) = 0.
            bkgisrerr(ibkg) = 0.
            bkgstaterr(ibkg) = 0.
            bkgjanerr(ibkg) = 0.
          enddo

c          write(*,*) nchan,channame(nchan)

          do iener = ilow_energy(iebin),ihigh_energy(iebin)
            ener = 199.+ 0.1*(iener-0.5)
            if (ener.lt.199.5) goto 2222
            if (ener.gt.210.0) goto 2222
            if (lumi_2000(iener).eq.0.) goto 2222
            if (mh.lt.75.) goto 2222
            if (mh.gt.120.) goto 2222

c            write(*,*) ener

            xlzh = xsec_interp(1,xsec,sngl(ener))*
     &             lumi_2000(iener)
c            write(*,*) 'hz ',xlzh
c            write(*,*) xsec_interp(1,xsec,sngl(ener)),lumi_2000(iener)
            xlww = xsec_interp(5,xsec,sngl(ener))*
     &             lumi_2000(iener)
            chanlumi(nchan) = chanlumi(nchan) + lumi_2000(iener)

c            write(*,*) 'nene ',xlww

            xdouble = mh

            rate(1) = z0tonn*2./3.*xlzh*
     >           (A2000_NN_SIG_EFF(ener,1,xdouble)*bhbb)
            rate(2) = z0tonn*2./3.*xlzh*
     >           (A2000_NN_SIG_EFF(ener,2,xdouble)*bhtata)
            rate(3) = z0tonn*2./3.*xlzh*
     >           (A2000_NN_SIG_EFF(ener,3,xdouble)*bhcc)
            rate(4) = z0tonn*2./3.*xlzh*
     >           (A2000_NN_SIG_EFF(ener,4,xdouble)*bhglgl)
            rate(5) = z0tonn*2./3.*xlzh*
     >           (A2000_NN_SIG_EFF(ener,5,xdouble)*bhWW)
            rate(6) = xlww*
     >           (A2000_NN_SIG_EFF(ener,6,xdouble)*bhbb)
            rate(7) = xlww*
     >           (A2000_NN_SIG_EFF(ener,7,xdouble)*bhtata)
            rate(8) = xlww*
     >           (A2000_NN_SIG_EFF(ener,8,xdouble)*bhcc)
            rate(9) = xlww*
     >           (A2000_NN_SIG_EFF(ener,9,xdouble)*bhglgl)
            rate(10) = xlww*
     >           (A2000_NN_SIG_EFF(ener,10,xdouble)*bhWW)

c            write(*,*) 'rates'
c            write(*,*) rate


c            write(*,*) 'Beginning signal loop'
            do isig = 1,10
c              write(*,*) isig
              if (rate(isig).lt.0.) rate(isig)=0.
c              write(*,*) rate(isig)

              sigtotal = sigtotal + rate(isig)
c              write(*,*) sigtotal

              sigstaterr(isig) = sigstaterr(isig) +
     >                   rate(isig)*sigstat(isig)

c              write(*,*) sigstaterr(isig)

c              write(*,*) 'Accessing signal shapes'
              call ascreateD(xl1,xu1,nbinsint1,A2000_nn_mrec_sig,
     >                       xdouble,isig,ener,sighist1)
c              write(*,*) 'Mass done'
              call ascreateD_fancy(xl2,xu2,nbinsint2,0.5,
     >                       A2000_nn_btag_sig,
     >                       xdouble,isig,ener,sighist2)
c              write(*,*) 'Btag done'
c Add together into 2D histogram.
              call a2dadd1(nbinsint1,nbinsint2,rate(isig),
     >                     sighist1,sighist2,sighist2d)
            enddo

c            write(*,*) 'Signal finished'

            do ibkg = 1,10
c              write(*,*) 'bkg',ibkg
c              write(*,*) 'Getting mass shape'
              call abhcreateD(xl1,xu1,nbinsint1,A2000_nn_mrec_bkg,
     >                        A2000_nn_bkg,ibkg,ener,backhist1)
c              write(*,*) 'Mass shape done'
              call abhcreateD_fancy(xl2,xu2,nbinsint1,0.5,
     >                        A2000_nn_btag_bkg,
     >                        A2000_nn_bkg,ibkg,ener,backhist2)
c              write(*,*) 'btag shape done'
              bkglevel = A2000_nn_bkg(ener,ibkg)*lumi_2000(iener)
c              write(*,*) 'bkg level',bkglevel
              bkgtotal = bkgtotal + bkglevel

c              write(*,*) 'Bkg level ',bkglevel,bkgtotal

              bkgstaterr(ibkg) = bkgstaterr(ibkg) +
     >                   bkglevel*bkgstat(ibkg)
              if (ibkg.le.5) then ! qq bkg
                bkge12err(ibkg) = bkge12err(ibkg) +
     >                   bkglevel*0.023
                bkgisrerr(ibkg) = bkgisrerr(ibkg) +
     >                   bkglevel*0.15
                bkgjanerr(ibkg) = bkgjanerr(ibkg) +
     >                   bkglevel*0.037
              else if (ibkg.le.7) then ! ww/wen bkg
                bkge12err(ibkg) = bkge12err(ibkg) +
     >                   bkglevel*0.043
                bkgwwxerr(ibkg) = bkgwwxerr(ibkg) +
     >                   bkglevel*0.025
                bkgjanerr(ibkg) = bkgjanerr(ibkg) +
     >                   bkglevel*0.050
              else ! zz/zee/znn bkg
                bkge12err(ibkg) = bkge12err(ibkg) +
     >                   bkglevel*0.014
                bkgzzxerr(ibkg) = bkgzzxerr(ibkg) +
     >                   bkglevel*0.025
                bkgjanerr(ibkg) = bkgjanerr(ibkg) +
     >                   bkglevel*0.011
              endif

c              write(*,*) 'Adding bkg'
              call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                     backhist1,backhist2,bkghist2d)

c              write(*,*) 'added'
            enddo

c            write(*,*) 'Background finished'

 2222       continue
          enddo

          do isig = 1,10
            dsig(6,nchan) = dsig(6,nchan) +
     >                      sigstaterr(isig)**2
          enddo

          if (sigtotal.gt.0.) then
            dsig(6,nchan) = sqrt(dsig(6,nchan))/sigtotal
          else
            dsig(6,nchan) = 0.
          endif

          do ibkg = 1,10
            dback(1,nchan) = dback(1,nchan) +
     >                      bkge12err(ibkg)
            dback(2,nchan) = dback(2,nchan) +
     >                      bkgwwxerr(ibkg)
            dback(3,nchan) = dback(3,nchan) +
     >                      bkgzzxerr(ibkg)
            dback(4,nchan) = dback(4,nchan) +
     >                      bkgisrerr(ibkg)
            dback(7,nchan) = dback(7,nchan) +
     >                      bkgstaterr(ibkg)**2
            dback(8,nchan) = dback(8,nchan) +
     >                      bkgjanerr(ibkg)
          enddo

          if (bkgtotal.gt.0.) then
            dback(1,nchan) = dback(1,nchan)/bkgtotal
            dback(2,nchan) = dback(2,nchan)/bkgtotal
            dback(3,nchan) = dback(3,nchan)/bkgtotal
            dback(4,nchan) = dback(4,nchan)/bkgtotal
            dback(7,nchan) = sqrt(dback(7,nchan))/bkgtotal
            dback(8,nchan) = dback(8,nchan)/bkgtotal
          else
            dback(1,nchan) = 0.
            dback(2,nchan) = 0.
            dback(3,nchan) = 0.
            dback(4,nchan) = 0.
            dback(7,nchan) = 0.
            dback(8,nchan) = 0.
          endif

          nacand = A2000_nn_NCAND()
          do i=1,nacand
            call A2000_nn_mhcand(i,candmass,candbtag,ener_cand)

            if ((ener_cand.ge.ener_min).and.
     &          (ener_cand.lt.ener_max)) then

              call abin1(candmass,xl1,xu1,
     >                   nbinsint1,ibin1)
              call abin_fancy(candbtag,xl2,xu2,
     >                   nbinsint2,0.5,ibin2)
              if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +          candhist2d(ibin1,ibin2) =
     +          candhist2d(ibin1,ibin2)+1
            endif
          enddo

          sigtotal = 0.
          bkgtotal = 0.
          do isig = 1,nbinsint1
            do ibkg = 1,nbinsint2
              sigtotal = sigtotal + sighist2d(isig,ibkg)
              bkgtotal = bkgtotal + bkghist2d(isig,ibkg)
            enddo
          enddo
c          write(*,*) 'Calling AREBIN: ',sigtotal,bkgtotal

          call arebin3(nbinsint1,nbinsint2,
     >                 sighist2d,bkghist2d,candhist2d,
     >                 nbinsint,
     >                 sig(nbins+1),backw(nbins+1),
     >                 ncand(nbins+1))
          sigtotal = 0.
          bkgtotal = 0.
          do isig = 1,nbinsint
            sigtotal = sigtotal + sig(nbins+isig)
            bkgtotal = bkgtotal + backw(nbins+isig)
          enddo
c          write(*,*) 'Left AREBIN: ',sigtotal,bkgtotal

c systematics
          if (.not.subbg) then
            call vzero(backg(nbins+1),nbinsint)
          elseif (dosyst) then
            call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                  nbinsint)
          else
            call vscale(backw(nbins+1),1.0,backg(nbins+1),
     >                  nbinsint)
          endif
          ifirst(nchan) = nbins + 1
          nbins = nbins + nbinsint

        enddo
      endif


