c
c nmax was almostly proportional to the whole usage of
c the memory, the ralitive uncertainty on clevel is
c roughly about the order of 10/nmax
c on Jul 25,1999 nmax2 is introduced. nmax used only for
c one channel's one particle's experiment's distribution,
c which can be smaller.
c
       integer mmax,nmax
       parameter (mmax = 18, nmax=2**mmax)

c a larger binning for all combined distribution

       integer mmax2,nmax2
       parameter (mmax2 = 19, nmax2=2**mmax2)

       integer nbin1d
       parameter (nbin1d=2**10)

       real*8 scale,scale1,scale2
       common /constant1/scale,scale1,scale2

       real*8 fstep
       common /constant2/fstep

       real*8 fmax,fmax1,fmax2
       common /constant3/fmax,fmax1,fmax2
c
c now control fmax_spare by *FMAX card.
       real*8 fmax_spare
       parameter (fmax_spare = 1.d0)
       real*8 fmax_factor
       parameter (fmax_factor = 1.1d0)

       integer n_type_sig_max
       parameter (n_type_sig_max=1)

       integer n_type_bkg_max
       parameter (n_type_bkg_max=1)

       integer num_obs_max
       parameter (num_obs_max = 100)
c
c num_ff1_max should be greater or equal num_opt_max, nch_max
c to save the memory, set it to be just as needed
c
       integer num_ff1_max
       parameter (num_ff1_max = 110)

       integer num_opt_max
       parameter (num_opt_max = 1)

       integer nch_max
       parameter (nch_max = 110)

       integer num_dis_max
       parameter (num_dis_max = 1)

       integer num_eff_max
       parameter (num_eff_max = 1)

       integer nstep1,nstep2,nstep3,nstepmax
       parameter (nstep1=1300, nstep2=200, nstep3=40)
       parameter (nstepmax = 10)

       real*8 area_eps
       parameter (area_eps = 1.d-4)
       real*8 area_s(n_type_sig_max,num_dis_max)
       real*8 area_st(n_type_sig_max,num_dis_max)
       real*8 area_b(n_type_bkg_max,num_dis_max)
       real*8 area_bt(n_type_bkg_max,num_dis_max)
       common /normalization/area_s,area_st,area_b,area_bt

       integer*8 num_step(num_dis_max),i_step(num_dis_max)
       real*8 dis_step(num_dis_max)

c
c parameter checks precision
c
       real*8 res_probn
       parameter (res_probn = 1.d-18)

       real*8 precision_machine
       parameter (precision_machine = 1.d-18)

       real*8 res_fmax_economic
       parameter (res_fmax_economic = 1.d-15)

       real*8 pbff1_last_bin_max
       parameter (pbff1_last_bin_max = 1.d-7)
c
c parameter and resolution for rdfreq function
c
       integer n_iter_rdfreq
       parameter (n_iter_rdfreq=100)
       real*8 smin,smax
       parameter (smin=-.8d1,smax=.8d1)
       real*8 pres1,pres2
       parameter (pres1=1.d-15,pres2=1.d-15)
c
c scanning MSSM parameter
c
       integer num_sin_ab_max
       parameter (num_sin_ab_max = 1)

       real*8 fmax_economic(num_sin_ab_max)
       real*8 fmax1_economic(num_sin_ab_max)
       real*8 fmax2_economic(num_sin_ab_max)
       common /fmax_control/fmax_economic,
     *        fmax1_economic,fmax2_economic

c below logL or logLR means the same thing, logLR is for tempary usage.

       integer num_scan_xsec_max
       parameter (num_scan_xsec_max = 40 + 1)
       real*8 logL(num_scan_xsec_max,num_opt_max,nch_max)
       real*8 logLR(num_scan_xsec_max)
       common /scan_xsec/logL,logLR
c
       integer n_dim_user_input_real,n_user_input_real
       parameter (n_dim_user_input_real=10,n_user_input_real=100)
c
       integer n_user_input_char
       parameter (n_user_input_char=10)

       integer syst_type
       common /syst/ syst_type