      FUNCTION effic_aleph(xmh,iene,ichn)                            
C-----------------------------------------------------------------------
C Inputs :   o xmh,   Higgs boson mass in GeV/c2, between 45 and 80
C            o iene   = 1 for 161 GeV
C                     = 2 for 170/172 GeV
C            o ichn   = 1 for (H->everything)(Z->nunu)
C                     = 2 for (H->everything)(Z->ll)
C                     = 3 for (H->bb)(Z->qq)
C                     = 4 for (H->everything)(Z->tt)
C                     = 5 for (H->tt)(Z->qq)
C-----------------------------------------------------------------------
C
      integer iene,ichn
      real xmh,effic_aleph
      integer nene,nchn,nmas
      PARAMETER (nene = 2, nchn = 5, nmas = 8 )
      real eff,xmas,effic                        
      DIMENSION eff(nmas,nene,nchn),xmas(nmas)
      integer imas
C                                                                       
      DATA eff /                                                        
C Hnunu @ 161                                                           
     .  0.243,0.312,0.388,0.405,0.402,0.265,0.168,0.101,                      
C Hnunu @ 172                                                           
     .  0.149,0.296,0.398,0.446,0.447,0.431,0.338,0.167,                      
C Hll @ 161                                                             
     .  0.728,0.732,0.746,0.753,0.740,0.642,0.260,0.049,
C Hll @ 172                                                             
     .  0.672,0.726,0.720,0.754,0.749,0.748,0.748,0.679,
C Hqq @ 161                                                             
     .  0.070,0.120,0.188,0.233,0.225,0.211,0.137,0.122,
C Hqq @ 172                                                             
     .  0.104,0.135,0.169,0.194,0.200,0.219,0.248,0.242,   
C qqtt @ 161                                                            
     .  0.160,0.213,0.192,0.183,0.239,0.178,0.142,0.125,                      
C qqtt @ 172                                                            
     .  0.173,0.191,0.192,0.197,0.201,0.195,0.238,0.169,
C ttqq @ 161                                                            
     .  0.037,0.073,0.141,0.207,0.210,0.174,0.111,0.064,                      
C ttqq @ 172                                                            
     .  0.014,0.040,0.060,0.103,0.189,0.174,0.177,0.137                      
C                                                                       
     .   /                                                              
C                                                                       
      DATA xmas / 45., 50., 55., 60., 65., 70., 75., 80. /                   

      DO imas = 1, nmas-1                                                 
*       WRITE(6,*) imas
*       WRITE(6,*) eff(imas,iene,ichn), eff(imas+1,iene,ichn) 
*       WRITE(6,*) xmas(imas),xmas(imas+1)
        IF ( xmh .LE. xmas(imas+1) ) THEN                                 
          effic =  eff(imas,iene,ichn)                                  
     .         + (eff(imas+1,iene,ichn)-eff(imas,iene,ichn))           
     .         / (xmas(imas+1)-xmas(imas))                             
     .         * (xmh-xmas(imas))
          IF ( effic .LE. 0. ) effic = 0.
          GOTO 10
        ELSEIF ( imas .EQ. nmas-1 ) THEN 
          effic = eff(nmas,iene,ichn)
          IF ( effic .LE. 0. ) effic = 0.
        ENDIF
      ENDDO                                                             
C      
 10   CONTINUE                                                          
C                                                       
      effic_aleph = effic
C                                                                       
      RETURN                                                            
      END                                
