C---------------------------------------------------------------------
C---------------------------------------------------------------------

      real*8 function A183_habbbb_eff(hmass,amass)

      IMPLICIT REAL*8(A-H,O-Z)

      dimension a1(183),b1(183),t1(183)
      dimension x1e(9),y1e(14),x1o(8),y1o(13),epse(9,14),epso(8,13)
      logical first
      data first /.true./

      if (first) then
        open(10,file='A183_habbbb_effdata.dat',status='old')
        do i = 1,9
          do j = 1,13
            epse(i,j) = 0.
          enddo
        enddo
        do i = 1,8
          do j = 1,12
            epso(i,j) = 0.
          enddo
        enddo
        do i = 1,9
          x1e(i) = 10.*float(i) + 70.
        enddo
        do i = 1,14
          y1e(i) = 10.*float(i) - 10.
        enddo
        do i = 1,8
          x1o(i) = 10.*float(i) + 75.
        enddo
        do i = 1,13
          y1o(i) = 10.*float(i) - 5.
        enddo
        k = 1
        do i = 1,183
          read(10,*) a1(i),b1(i),t1(i)
          do k = 1,9
            do l = 1,14
              if ((abs(a1(i)+b1(i)-x1e(k)).lt.1.).and.
     &            (abs(abs(a1(i)-b1(i))-y1e(l)).lt.1.)) then
                epse(k,l) = t1(i)
              endif
            enddo
          enddo
          do k = 1,8
            do l = 1,13
              if ((abs(a1(i)+b1(i)-x1o(k)).lt.1.).and.
     &            (abs(abs(a1(i)-b1(i))-y1o(l)).lt.1.)) then
                epso(k,l) = t1(i)
              endif
            enddo
          enddo
        enddo

        close(10)
        first = .false.
      endif

      efftmp = 0.

      summass = amass+hmass
      diffmass = abs(amass-hmass)

      if (summass.gt.170.) goto 999
      if (summass.lt.80.) goto 999
      if (amass.lt.10.) goto 999
      if (hmass.lt.10.) goto 999
      if (diffmass.gt.125.) goto 999

      do ke = 1,14
        if (((diffmass-y1e(ke)).lt.5.).and.
     &      ((y1e(ke)-diffmass).le.5.)) then
          kebest = ke
        endif
      enddo
      if (summass.ge.160.) then
        lle = 8
        lhe = 9
      else
        do le = 1,8
          if ((summass.ge.x1e(le)).and.
     &        (summass.lt.x1e(le+1))) then
            lle = le
            lhe = le+1
          endif
        enddo
      endif
      do ko = 1,13
        if (((diffmass-y1o(ko)).lt.5.).and.
     &      ((y1o(ko)-diffmass).le.5.)) then
          kobest = ko
        endif
      enddo

      if (summass.lt.85.) then
        llo = 1
        lho = 2
      else if (summass.ge.155.) then
        llo = 7
        lho = 8
      else
        do lo = 1,7
          if ((summass.ge.x1o(lo)).and.
     &        (summass.lt.x1o(lo+1))) then
            llo = lo
            lho = lo+1
          endif
        enddo
      endif

      wde1 = (x1e(lhe)-summass)/(x1e(lhe)-x1e(lle))
      wde2 = (summass-x1e(lle))/(x1e(lhe)-x1e(lle))

      effde = epse(lle,kebest)*wde1 + epse(lhe,kebest)*wde2

      wdo1 = (x1o(lho)-summass)/(x1o(lho)-x1o(llo))
      wdo2 = (summass-x1o(llo))/(x1o(lho)-x1o(llo))

      effdo = epso(llo,kobest)*wdo1 + epso(lho,kobest)*wdo2

      ws1  = (y1e(kebest)-diffmass)/(y1e(kebest)-y1o(kobest))
      ws2  = (diffmass-y1o(kobest))/(y1e(kebest)-y1o(kobest))

      efftmp = ws1*effdo + ws2*effde

 999  CONTINUE

      A183_habbbb_eff = efftmp

      end

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      real*8 function A183_habbbb_bkg()

      A183_habbbb_bkg = 2.41D0

      end

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      integer function A183_habbbb_numcand()

      A183_habbbb_numcand = 2

      end

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      real*8 function A183_habbbb_mass_cand(ICAND)

      implicit real*8(A-H,O-Z)

      A183_habbbb_mass_cand = 0D0
      if (ICAND.eq.1) then
        A183_habbbb_mass_cand = 57.8D0
      else if (ICAND.eq.2) then
        A183_habbbb_mass_cand = 130.2D0
      endif

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      real*8 function A183_habbbb_btag_cand(ICAND)

      implicit real*8(A-H,O-Z)

      A183_habbbb_btag_cand = 0D0
      if (ICAND.eq.1) then
        A183_habbbb_btag_cand = 44.97D0
      else if (ICAND.eq.2) then
        A183_habbbb_btag_cand = 59.09D0
      endif

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      double precision function A183_habbbb_mass_sig(x,hmass,amass)
      IMPLICIT REAL*8(A-H,O-Z)
      dimension par(10),par2(10),par1(10)
c      common /sft/ summass

      PARAMETER (XMIN=70D0,XMAX=183D0)

      summass = (hmass+amass)/2.

      PAR1( 1) = 138.249D0
      PAR1( 2) = 2.79622D0
      PAR1( 3) = 240.276D0
      PAR1( 4) = 135.760D0
      PAR1( 5) = 35.5633D0
      PAR1( 6) = 468.609D0
      PAR1( 7) = 138.095D0
      PAR1( 8) = 8.73528D0
      PAR1( 9) = 291.115D0

      PAR2( 1) = 147.987D0
      PAR2( 2) = 3.10507D0
      PAR2( 3) = 299.496D0
      PAR2( 4) = 133.104D0
      PAR2( 5) = 36.6756D0
      PAR2( 6) = 431.569D0
      PAR2( 7) = 148.444D0
      PAR2( 8) = 11.1965D0
      PAR2( 9) = 268.935D0

      do i=1,9
        par(i)=par1(i)+(par2(i)-par1(i))*(SUMMASS-70.)/5.
      enddo


      temp = 0D0
      y = (x-PAR(1))/PAR(2)
      y = -y*y
      if (abs(y).lt.100.) then
        y = PAR(3)*exp(y)/PAR(2)
        temp = temp + y
      endif

      y = (x-PAR(4))/PAR(5)
      y = -y*y
      y = PAR(6)*exp(y)/PAR(5)
      temp = temp + y

c      write(*,*) temp

      y = (x-PAR(7))/PAR(8)
      y = -y*y
      y = PAR(9)*exp(y)/PAR(8)
      temp = temp + y

      A183_habbbb_mass_sig = temp
      IF (X.LT.XMIN) A183_HABBBB_MASS_SIG = 0.
      IF (X.GT.XMAX) A183_HABBBB_MASS_SIG = 0.

      RETURN
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HABBBB_MASS_BKG(V)
      DOUBLE PRECISION V( 1)

      DOUBLE PRECISION XMAX,XMIN
      PARAMETER(XMIN=70D0,XMAX=183D0)

      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(  61, 1)
      DOUBLE PRECISION SIGDEL(  61)
      DOUBLE PRECISION SIGA(  61)
      DATA NPAR, NDIM, IMQFUN /   61,    1,    1/
      DATA VCONST /  2.000000000000    /
      DATA SIGVMI /  70.00000000000    /
      DATA SIGVT /  113.0000000000    /
      DATA SIGV / 0.1499999966472E-01
     +, 0.2499999850988E-01
     +, 0.3500000014901E-01
     +, 0.4499999806285E-01
     +, 0.5499999970198E-01
     +, 0.6499999761581E-01
     +, 0.7499999552965E-01
     +, 0.1049999967217    
     +, 0.1149999946356    
     +, 0.1250000000000    
     +, 0.1349999904633    
     +, 0.1449999958277    
     +, 0.1550000011921    
     +, 0.1649999916553    
     +, 0.2249999940395    
     +, 0.2349999994040    
     +, 0.4849999845028    
     +, 0.4949999749660    
     +, 0.5249999761581    
     +, 0.5349999666214    
     +, 0.6949999928474    
     +, 0.7049999833107    
     +, 0.7349999547005    
     +, 0.7450000047684    
     +, 0.7549999952316    
     +, 0.7649999856949    
     +, 0.7749999761581    
     +, 0.7849999666214    
     +, 0.7949999570847    
     +, 0.8050000071526    
     +, 0.8149999976158    
     +, 0.8249999880791    
     +, 0.8349999785423    
     +, 0.8449999690056    
     +, 0.8549999594688    
     +, 0.8650000095367    
     +, 0.8750000000000    
     +, 0.8849999904633    
     +, 0.8949999809265    
     +, 0.9049999713898    
     +, 0.9149999618530    
     +, 0.9249999523163    
     +, 0.9350000023842    
     +, 0.9449999928474    
     +, 0.9549999833107    
     +, 0.9649999737740    
     +, 0.9849999547005    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.1899999976158    
     +, 0.2699999809265    
     +, 0.2899999916553    
     +, 0.3100000023842    
     +, 0.3299999833107    
     +, 0.3499999940395    
     +, 0.3700000047684    
     +, 0.3899999856949    
     +, 0.5699999928474    
     +, 0.5899999737740    
     +, 0.6100000143051    
     +, 0.6699999570847    
     +/
      DATA SIGDEL / 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999955297E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +/
      DATA SIGA /-0.7535403593057E-01
     +, 0.8071967662111E-01
     +, 0.1565398658266E-02
     +, 0.4495906831043E-02
     +, 0.8460330208308E-02
     +, 0.4532648842523E-02
     +, 0.1002637537691E-01
     +,-0.4530289097889E-02
     +,-0.2836811068742E-01
     +, 0.1604997804701E-01
     +,-0.6279641189131E-01
     +, 0.3476819169660E-01
     +,-0.6298486025141E-01
     +, 0.1422282171023E-01
     +,-0.1383874348546E-01
     +, 0.3057881099925E-01
     +,-0.1181111822952E-02
     +, 0.3654246302651E-01
     +,-0.3844314774013E-01
     +, 0.5941956869175E-02
     +, 0.3130395542287E-01
     +,-0.7695490577876E-01
     +, 0.4253335084818E-01
     +,-0.5739455256722E-01
     +, 0.1261300571679    
     +,-0.2355968125434E-02
     +, 0.1258467071142    
     +, 0.1893316005698    
     +,-0.7105640525067    
     +, 0.5436174032197E-01
     +, 0.8264778221596E-01
     +, 0.2957141515966E-01
     +, 0.3653488974286E-01
     +, 0.1776059683967E-01
     +, 0.1267965131760E-01
     +, 0.2108160844418E-01
     +, 0.1085850015662E-01
     +, 0.1589691014909E-01
     +,-0.1138078925148E-02
     +, 0.2337275510098E-01
     +,-0.1058723515306E-01
     +, 0.1591760799239    
     +,-0.7925720332929E-01
     +,-0.7803430162891E-01
     +,-0.4749855530836E-01
     +,-0.5646807061908E-01
     +, 0.9688763106302E-01
     +, 0.5694729198140E-01
     +, 0.4722060013386E-01
     +, 0.2094653431822E-01
     +, 0.7879316388974E-02
     +, 0.4737913605956E-02
     +,-0.4872160320786E-01
     +, 0.5515763808260E-01
     +,-0.7659990208166E-01
     +, 0.4255496262932E-01
     +,-0.1721034434413E-01
     +,-0.1019795860846E-01
     +, 0.7128079440939E-02
     +,-0.1345757168825E-01
     +, 0.1595605921280E-01
     +/
      A183_HABBBB_MASS_BKG = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HABBBB_MASS_BKG =
     &          A183_HABBBB_MASS_BKG + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HABBBB_MASS_BKG =
     &          VCONST * EXP (A183_HABBBB_MASS_BKG)

      IF (V(1).lt.XMIN) A183_HABBBB_MASS_BKG = 0.
      IF (V(1).gt.XMAX) A183_HABBBB_MASS_BKG = 0.
      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_HABBBB_BTAG_SIG(V)
      DOUBLE PRECISION V( 1)

      DOUBLE PRECISION XMIN,XMAX
      PARAMETER(XMIN=-100D0,XMAX=67D0)

      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   6, 1)
      DOUBLE PRECISION SIGDEL(   6)
      DOUBLE PRECISION SIGA(   6)
      DATA NPAR, NDIM, IMQFUN /    6,    1,    2/
      DATA VCONST /  4.000000000000    /
      DATA SIGVMI / -100.0000000000    /
      DATA SIGVT /  200.0000000000    /
      DATA SIGV / 0.8100000023842    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.2199999988079    
     +, 0.1199999973178    
     +, 0.6800000071526    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +, 0.1599999964237    
     +/
      DATA SIGA /-0.7793871944023E-01
     +,  12.82045146427    
     +,  2.785133074077    
     +, -4.053166113027    
     +, -5.955203327282    
     +, -1.737878094360    
     +/
      A183_HABBBB_BTAG_SIG = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_HABBBB_BTAG_SIG =
     &        A183_HABBBB_BTAG_SIG + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_HABBBB_BTAG_SIG =
     &        VCONST * EXP (A183_HABBBB_BTAG_SIG)

      IF (V(1).LT.XMIN) A183_HABBBB_BTAG_SIG = 0.
      IF (V(1).GT.XMAX) A183_HABBBB_BTAG_SIG = 0.

      END

C---------------------------------------------------------------------
C---------------------------------------------------------------------

      DOUBLE PRECISION FUNCTION A183_habbbb_btag_bkg(V)
      DOUBLE PRECISION V( 1)

      DOUBLE PRECISION XMIN,XMAX
      PARAMETER (XMIN=-100D0,XMAX=67D0)

      INTEGER NPAR, NDIM, IMQFUN, I, J
      DOUBLE PRECISION HQDJ, VV, VCONST
      DOUBLE PRECISION SIGVMI( 1), SIGVT( 1)
      DOUBLE PRECISION SIGV(   8, 1)
      DOUBLE PRECISION SIGDEL(   8)
      DOUBLE PRECISION SIGA(   8)
      DATA NPAR, NDIM, IMQFUN /    8,    1,    1/
      DATA VCONST /  4.000000000000    /
      DATA SIGVMI / -100.0000000000    /
      DATA SIGVT /  200.0000000000    /
      DATA SIGV / 0.6299999952316    
     +, 0.7299999594688    
     +, 0.8700000047684    
     +, 0.8899999856949    
     +, 0.0000000000000E+00
     +,  1.000000000000    
     +, 0.8199999928474    
     +, 0.2800000011921    
     +/
      DATA SIGDEL / 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.3999999910593E-01
     +, 0.1999999994950E-05
     +, 0.1999999994950E-05
     +, 0.7999999821186E-01
     +, 0.1599999964237    
     +/
      DATA SIGA / 0.2153070731702    
     +, 0.6668901317199    
     +, 0.2365769467634    
     +,  2.083952310083    
     +, 0.7072288317713    
     +, -3.490434919495    
     +, 0.9542253760829    
     +, 0.5644926276590E-01
     +/
      A183_habbbb_btag_bkg = 0.
      DO 20 J = 1, NPAR
         HQDJ = 0.
         DO 10 I = 1, NDIM
            VV = (V (I) - SIGVMI (I)) / SIGVT (I)
            HQDJ = HQDJ + (VV - SIGV (J, I)) ** 2
   10    CONTINUE
         HQDJ = HQDJ + SIGDEL (J) ** 2
         HQDJ = SQRT (HQDJ)
         A183_habbbb_btag_bkg =
     &        A183_habbbb_btag_bkg + SIGA (J) * HQDJ
   20 CONTINUE
      IF (IMQFUN .EQ. 2) A183_habbbb_btag_bkg =
     &        VCONST * EXP (A183_habbbb_btag_bkg)

      IF (V(1).LT.XMIN) A183_habbbb_btag_bkg = 0.
      IF (V(1).GT.XMAX) A183_habbbb_btag_bkg = 0.
      END
