C-*-FORTRAN-*-
      DO IENER=3,6
c
         switch = .true.
         dosyst = .true.
         subbg = .true.
         if (switch) then
            nchan = nchan + 1 
            xxll = (xheetot(13+iener) + xhz(13+iener)*z0tomumu)
     +           * ah0_lumi(iener)
            xxll2 = (xheetot2(13+iener) + xhz2(13+iener)*z0tomumu)
     +           * ah0_lumi(iener)
            chanlumi(nchan) = ah0_lumi(iener)
            xdouble = mh
            xdouble2 = mh2
            
            IF (IENER.EQ.3) THEN 
               channame(nchan) = 'ALEPH 192 Hll'
               xl1 = 50.
               xu1 = 114.
            ELSE IF (IENER.EQ.4) THEN      
               channame(nchan) = 'ALEPH 196 Hll'
               xl1 = 50.
               xu1 = 118.
            ELSE IF (IENER.EQ.5) THEN      
               channame(nchan) = 'ALEPH 200 Hll'
               xl1 = 50.
               xu1 = 120.
            ELSE IF (IENER.EQ.6) THEN      
               channame(nchan) = 'ALEPH 202 Hll'
               xl1 = 50.
               xu1 = 120.
            END IF                    
            
      ratech  =xxll * SNGL(a_hll_eff_bb_1999(xdouble,iener)) * bhbb
      rate2ch =xxll * SNGL(a_hll_eff_tt_1999(xdouble,iener)) * bhtata
      rate3ch =xxll * SNGL(a_hll_eff_other_1999(xdouble,iener))  
     +           * (bhcc+bhglgl)
      ratech2  =xxll2*SNGL(a_hll_eff_bb_1999(xdouble2,iener))*bhbb2
      rate2ch2 =xxll2*SNGL(a_hll_eff_tt_1999(xdouble2,iener))*bhtata2
      rate3ch2 =xxll2*SNGL(a_hll_eff_other_1999(xdouble2,iener))  
     +           * (bhcc2+bhglgl2)
c     
      if (ratech.lt.0.0) ratech=0.0
      if (rate2ch.lt.0.0) rate2ch=0.0
      if (rate3ch.lt.0.0) rate3ch=0.0
c     
c     Create binned pdf info:
c     Upper and lower bounds for the 1st (m) and 2nd (btau-tag) discriminant,
c     and nos. of bins:
c     xl1, xu1
c     
            xl2 = 0.0
            xu2 = 2.0
c
            nbinsint1 = 100
            nbinsint2 = 100
            nbinsint  = 100
            IF (CHANLUMI(NCHAN).EQ.0.0) GOTO 1923 ! NEXT CHANNEL
c
c---- Prepare binned SIGNAL pdf:
c
         if (xtest19x) write (6,*) 'Hll sig-pdfs: iener',iener
         call a2dzero1(nbinsint1,nbinsint2,sighist2d)
         call a2dzero1(nbinsint1,nbinsint2,sighist2d2)
c     h --> bb
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_bb,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,ratech,
     >                sighist1,sighist2,sighist2d)
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh2,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_bb,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,ratech2,
     >                sighist1,sighist2,sighist2d2)
c     h --> tau tau
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_tt,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate2ch,
     >                sighist1,sighist2,sighist2d)
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh2,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_tt,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate2ch2,
     >                sighist1,sighist2,sighist2d2)
c     h --> cc + gg
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_other,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate3ch,
     >                sighist1,sighist2,sighist2d)
         call ascreate2(xl1,xu1,nbinsint1,a_hll_sig_h0mass,
     >        mh2,iener,sighist1) 
         call ascreate5(xl2,xu2,nbinsint2,a200_hll_sig_btag_other,
     >        sighist2)
         call a2dadd1(nbinsint1,nbinsint2,rate3ch2,
     >                sighist1,sighist2,sighist2d2)

c
c---- Prepare binned BACKGROUND shape:
c
         if (xtest19x) write (6,*) 'Hll bkg-pdfs: iener',iener
         call a2dzero1(nbinsint1,nbinsint2,bkghist2d)
c-- ZZ
         call abhcreate7(xl1,xu1,nbinsint1,a_hll_bkg_mass,
     >                   a_hll_bkg_level,iener,1,backhist1)
         call abhcreate7(xl2,xu2,nbinsint2,a_hll_bkg_btag,
     >                   a_hll_bkg_level,iener,1,backhist2)
         bkglevel = SNGL(a_hll_bkg_level(iener,1))
         ratebgd(1) = bkglevel
         call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                backhist1,backhist2,bkghist2d)
c-- eeZ
         call abhcreate7(xl1,xu1,nbinsint1,a_hll_bkg_mass,
     >                   a_hll_bkg_level,iener,2,backhist1)
         call abhcreate7(xl2,xu2,nbinsint2,a_hll_bkg_btag,
     >                   a_hll_bkg_level,iener,2,backhist2)
         bkglevel = SNGL(a_hll_bkg_level(iener,2))
         ratebgd(2) = bkglevel
         call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                backhist1,backhist2,bkghist2d)
c-- other
         call abhcreate7(xl1,xu1,nbinsint1,a_hll_bkg_mass,
     >                   a_hll_bkg_level,iener,3,backhist1)
         call abhcreate7(xl2,xu2,nbinsint2,a_hll_bkg_btag,
     >                   a_hll_bkg_level,iener,3,backhist2)
         bkglevel = SNGL(a_hll_bkg_level(iener,3))
         ratebgd(3) = bkglevel
         call a2dadd1(nbinsint1,nbinsint2,bkglevel,
     >                backhist1,backhist2,bkghist2d)
c
c---- Prepare histogram with the CANDIDATES:
c
         call a2dzero2(nbinsint1,nbinsint2,candhist2d)
         nacand = a_hll_numcand(iener)
         do i=1,nacand
           candmass = a_hll_mass_cand(iener,i)
           candbtag = a_hll_btag_cand(iener,i)
           call abin1(candmass,xl1,xu1,
     >                nbinsint1,ibin1)
           call abin1(candbtag,xl2,xu2,
     >                nbinsint2,ibin2)
           if (ibin1.gt.0 .AND. ibin2.gt.0 .AND. 
     +          ibin1.le.nbinsint1 .AND. ibin2.le.nbinsint2)
     +          candhist2d(ibin1,ibin2) = candhist2d(ibin1,ibin2)+1
        enddo
c
        call arebin5(nbinsint1,nbinsint2,
     >                sighist2d,sighist2d2,bkghist2d,candhist2d,
     >                nbinsint,sig(nbins+1),
     >                sig2(nbins+1),backw(nbins+1),ncand(nbins+1))
c
c Fill in the SYSTEMATIC ERROR information:
c
        ratesig(1) = ratech     ! bbll
        ratesig(2) = rate2ch    ! ttll
        ratesig(3) = rate3ch    ! (cc+gg)ll
c       ratebgd(1/2/3) = ZZ/eeZ/other 
c
c     (NB for the 1999 analyses, the 2nd input to the following s/r is
c         dummy...)
c
        CALL A_HLL_SYSTEMATICS(IENER,RATESIG,RATEBGD, ! input
     +       dsig(1,nchan),dback(1,nchan),sysname(1,nchan), ! output
     +       nerrch(nchan))     ! output
c
c        write (6,*) 'returned from A_HLL_SYSTEMATICS'
c        write (6,*) 'nerrch_aux',nerrch_aux
c        write (6,*) 'dsig_aux',dsig_aux
c        write (6,*) 'dback_aux',dback_aux
c        write (6,*) 'sysname_aux',sysname_aux
c
c        nerrch(nchan) = nerrch_aux
c        do i=1,nerrch_aux
c           dsig(i,nchan) = dsig_aux(i)
c           dback(i,nchan) = dback_aux(i)
c           sysname(i,nchan) = sysname_aux(i)
c        end do
cc
c        write (6,*) 'copied/from A_HLL_SYSTEMATICS'
c        write (6,*) 'nerrch(nchan)',nerrch(nchan)
c        write (6,*) 'dsig(1,nchan)',(dsig(i,nchan),i=1,nerrch(nchan))
c        write (6,*) 'dback(1,nchan)',(dback(i,nchan),i=1,nerrch(nchan))
c        write (6,*) 'sysname(1,nchan)',
c     +       (sysname(i,nchan),i=1,nerrch(nchan))
c
c     systematics
c
         if (.not.subbg) then
            call vzero(backg(nbins+1),nbinsint)
         elseif (dosyst) then
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
         else
            call vscale(backw(nbins+1),1.0,backg(nbins+1),nbinsint)
         endif
 1923    ifirst(nchan) = nbins + 1
         nbins = nbins + nbinsint
      endif                     ! (switch)
c
      END DO                    ! hll / iener = 3,6

