c-*-FORTRAN-*-
c
c Input declarations for the ALEPH inputs: a_inputs.f
c
c Number of different energies for
c  cross sections and channels

	integer a_maxnener
	parameter (a_maxnener=35)

c Maximum allowed number of ALEPH search channels:

	integer a_maxnchan
	parameter (a_maxnchan=200)

c Total number of histogram bins if all
c histograms are laid end-to-end in a single array

	integer a_maxnbin
	parameter (a_maxnbin=20000)

c Maximum allowed number of error sources per channel

	integer a_maxnerr
	parameter (a_maxnerr=20)

c good to use it as the same lun for
c reading in the histos is also used for writing out the histos

	integer a_histoutlun
	parameter (a_histoutlun=11)

	integer a_histinlun
	parameter (a_histinlun=11)
c
c     xsec, efixup & xmass array dimensions:
c
      integer nxsec,nroots,nmass
      parameter (nxsec=7,nroots=40,nmass=4) 
c



